<?php
/**
 * @package flatnux_blocks
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */

if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
switch ($_FN['lang'])
{
	case "it" :
		define("_AKSHOW","Accesskey ON");
		define("_AKHIDE","Accesskey OFF");
		define("_AKFONTSIZE","Dimensione dei caratteri");
		define("_AKDEC","Diminuisci la dimensione dei caratteri");
		define("_AKINC","Aumenta la dimensione dei caratteri");
		define("_SITE_HC","Sito ad alto contrasto");
		define("_SITE_LC","Sito a contrasto normale");
	
	break;
	case "en" :
	default :
		define("_AKSHOW","Accesskey ON");
		define("_AKHIDE","Accesskey OFF");
		define("_AKFONTSIZE","Font size");
		define("_AKDEC","Decrease font size");
		define("_AKINC","Increase font size");
		define("_SITE_HC","High Contrast");
		define("_SITE_LC","Normal contrast");
	break;
}
$_AKSHOW = fn_i18n("_AKSHOW");
$_AKHIDE = fn_i18n("_AKHIDE");
$_SITE_HC = fn_i18n("_SITE_HC");
$_SITE_LC = fn_i18n("_SITE_LC");

if ( file_exists("themes/{$_FN['theme']}_HC") )
{
	$a = getaccesskey($_SITE_HC,"theme={$_FN['theme']}_HC");
	echo "<div style=\"text-align:center\"><a accesskey=\"$a\" href=\"?theme={$_FN['theme']}_HC\">$_SITE_HC</a></div>";
}
else
{
	if ( fn_erg('_HC$',$_FN['theme']) )
	{
		$theme_lc = fn_erg_replace("_HC","",$_FN['theme']);
		$a = getaccesskey($_SITE_LC,"theme=$theme_lc");
		
		echo "<div style=\"text-align:center\"><a accesskey=\"$a\" href=\"?theme=$theme_lc\">$_SITE_LC</a>";
		pmbuttons();
		echo "</div>";
	}
}

if ( $_FN['showaccesskey'] == 0 )
{
	$a = getaccesskey($_AKSHOW,"showaccesskey=1");
	echo "<div style=\"text-align:center\"><a accesskey=\"$a\" href=\"?showaccesskey=1\">[$a]$_AKSHOW</a></div>";
}
else
{
	$a = getaccesskey($_AKHIDE,"showaccesskey=0");
	echo "<div style=\"text-align:center\"><a accesskey=\"$a\" href=\"?showaccesskey=0\">$_AKHIDE</a></div><br />";

}

function pmbuttons()
{
	echo "<br /><br />" . fn_i18n("_AKFONTSIZE") . "<br />";
	echo "<button class=\"decreaseFontSize\" title=\"" . fn_i18n("_AKDEC") . "\"  accesskey=\"-\" onclick=\"decreaseFontSize()\">-</button>&nbsp;<button class=\"increaseFontSize\" title=\"" . fn_i18n("_AKINC") . "\" onclick=\"increaseFontSize()\"  accesskey=\"+\" >+</button>";
	echo "";
	echo '
	<script type="text/javascript">
measureUnit = "px";minSize = 1;minStyleSize = 10;maxSize = 6;
maxStyleSize = 30;startSize = 1;startStyleSize = 10;stepSize = 1;
stepStyleSize = 2;var keyin = 61;var keyinCAPS = 43;var keyout = 45;
var keyoutCAPS = 95;var keyinIe = 46;var keyinIeCAPS = 62;var keyoutIe = 44;
var keyoutIeCAPS = 60;var zoomFactor = 1.1;var maxZoom = 4.096;var minZoom = 0.625;
var startDecZoom = 0.7;var startIncZoom = 1.3;userExpiry = 365 * 24 * 60 * 60 * 1000;
alertEnabled = false;allowInputResize = false;

function searchTags(childTree, level) {
  var retArray = new Array();
  var tmpArray = new Array();
  var j = 0;
  var childName = "";
  for (var i=0; i<childTree.length; i++) {
    childName = childTree[i].nodeName;
    if (childTree[i].hasChildNodes()) {
      if ((childTree[i].childNodes.length == 1) && (childTree[i].childNodes[0].nodeName == "#text"))
        retArray[j++] = childTree[i];
      else {
        tmpArray = searchTags(childTree[i].childNodes, level+1);
        for (var k=0;k<tmpArray.length; k++)
          retArray[j++] = tmpArray[k];
        retArray[j++] = childTree[i];
      }
    }
    else
      retArray[j++] = childTree[i];
  }
  return(retArray);
}
function changeFontSize(stepSize, stepStyleSize) {
  if (document.body) {
    var myObj = searchTags(document.body.childNodes, 0);
    var myStepSize = stepSize;
    var myStepStyleSize = stepStyleSize;
    myObjNumChilds = myObj.length;
    for (i=0; i<myObjNumChilds; i++) {
      myObjName = myObj[i].nodeName;
      if (myObjName != "#text" && myObjName != "HTML" &&
          myObjName != "HEAD" && myObjName != "TITLE" &&
          myObjName != "STYLE" && myObjName != "SCRIPT" &&
          myObjName != "BR" && myObjName != "TBODY" &&
          myObjName != "#comment" && myObjName != "FORM") {
        if (!allowInputResize && myObjName == "INPUT") continue;
        size = parseInt(myObj[i].getAttribute("size"));
        if (myObj[i].currentStyle)
          styleSize = parseInt(myObj[i].currentStyle.fontSize);
        else 
          styleSize = parseInt(window.getComputedStyle(myObj[i], null).fontSize);
        if (isNaN(size) || (size < minSize) || (size > maxSize))
          size = startSize;
        if (isNaN(styleSize) || (styleSize < minStyleSize) || (styleSize > maxStyleSize))
          styleSize = startStyleSize;
        if ( ((size > minSize) && (size < maxSize)) || 
             ((size == minSize) && (stepSize > 0)) || 
             ((size == maxSize) && (stepSize < 0))) {
          myObj[i].setAttribute("size", size+myStepSize);
        }
        if ( ((styleSize > minStyleSize) && (styleSize < maxStyleSize)) || 
             ((styleSize == minStyleSize) && (stepStyleSize > 0)) ||
             ((styleSize == maxStyleSize) && (stepStyleSize < 0))) {
          newStyleSize = styleSize+myStepStyleSize;
          myObj[i].style.fontSize = newStyleSize+measureUnit;
        }
      } // End if condition ("only some tags")
    } // End main for cycle
  } // End if condition ("document.body exists")
} // End function declaration

increaseFontSize = function () {
  if (document.body) {
    changeFontSize(stepSize, stepStyleSize, false);
  }
  else {
    if (alertEnabled) {
      alert("Spiacente, il tuo browser non supporta questa funzione");
    }
  }
}

decreaseFontSize = function () {
  if (document.body) {
    myStepSize = -stepSize;
    myStepStyleSize = -stepStyleSize;
    changeFontSize(myStepSize, myStepStyleSize, false);
  }
  else {
    if (alertEnabled) {
      alert("Spiacente, il tuo browser non supporta questa funzione");
    }
  }
}

function zoomin() {
  if (window.parent.document.body.style.zoom < maxZoom) {
    if (window.parent.document.body.style.zoom > 0) {
      window.parent.document.body.style.zoom *= zoomFactor; 
    }
    else { 
      window.parent.document.body.style.zoom = startIncZoom;
    }
  }
  else {
    if (alertEnabled) {
      alert("Warning: Max size reached");
    }
  }
}

function zoomout() {
  if ( (window.parent.document.body.style.zoom > minZoom) ||
       (window.parent.document.body.style.zoom == 0) ) {
    if (window.parent.document.body.style.zoom > 0) {
      window.parent.document.body.style.zoom /= zoomFactor; 
    }
    else {
      window.parent.document.body.style.zoom = startDecZoom;
    }
  }
  else {
    if (alertEnabled) {
      alert("Warning: Min size reached");
    }
  }
}

</script>
';
}
?>