<?php
/**
 * @package flatnux_blocks
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */

if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
$table = new XMLTable("fndatabase","stat_usersonline",$_FN['datadir']);
$all = $table->GetRecords();
$guest = 0;
uo_set_lang($_FN['lang']);
$admin = array();
$users = array();
if ( is_array($all) )
	foreach ( $all as $user )
	{
		if ( $user['user'] == "" )
		{
			$guest++ ;
		}
		else
		{
			$u = get_user($user['user']);
			if ( $u['level'] == 10 )
				$admin[] = $user['user'];
			else
				$users[] = $user['user'];
		}
	}
echo "<div id=\"userblock\">";
echo "<b>" . fn_i18n("_UO_USERS_ONLINE") . "</b>";
//------amministratori------------------
echo "<br />" . add_image("group-admins") . count($admin) . " " . fn_i18n("_UO_ADMINISTRATORS");
foreach ( $admin as $u )
{
	echo "<br />&nbsp;" . add_image("usr-admin") . "<a title=\"" . fn_i18n("_UO_VIEW_PROFILE") . "\" href=\"index.php?mod=login&amp;opmod=profile&amp;user=$u\" >" . "" . $u . "</a>";
}
//------utenti------------------
echo "<br />" . add_image("group-users") . count($users) . " " . fn_i18n("_UO_USERS");
foreach ( $users as $u )
{
	echo "<br />&nbsp;" . add_image("usr-user") . "<a title=\"" . fn_i18n("_UO_VIEW_PROFILE") . "\" href=\"index.php?mod=login&amp;opmod=profile&amp;user=$u\" >" . "" . $u . "</a>";
}
//------ospiti------------------
echo "<br />" . add_image("group-guests") . $guest . " " . fn_i18n("_UO_GUESTS");

function add_image($type)
{
	if (  !isset($type) )
		return "";
	$imgt = fromtheme("images/useronline/$type.gif");
	if ( file_exists($imgt) )
	{
		return "<img src=\"$imgt\" alt=\"" . preg_replace("/group-|usr-/","",$type) . "\" />&nbsp;";
	}
	else
		return "";
}

/**
 * 
 * @param strng $lang
 */
function uo_set_lang($lang)
{
	if (  !isset($lang) )
		$lang = "en";
	if ( $lang == "it" )
	{
		define("_UO_USERS_ONLINE","Persone&nbsp;on-line:");
		define("_UO_USERS","utenti");
		define("_UO_ADMINISTRATORS","amministratori");
		define("_UO_GUESTS","ospiti");
		define("_UO_VIEW_PROFILE","Visualizza il profilo dell'utente");
	}
	else 
		if ( $lang == "de" )
		{
			define("_UO_USERS_ONLINE","Personen&nbsp;on-line:&nbsp;&nbsp;");
			define("_UO_USERS","Angemeldete");
			define("_UO_ADMINISTRATORS","Administratoren");
			define("_UO_GUESTS","Gste");
			define("_UO_VIEW_PROFILE","Userprofil ansehen.");
		}
		else
		{
			define("_UO_USERS_ONLINE","People&nbsp;on-line:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
			define("_UO_USERS","users");
			define("_UO_ADMINISTRATORS","administrators");
			define("_UO_GUESTS","guests");
			define("_UO_VIEW_PROFILE","View user's profile");
		}
}

echo "</div>";
?>
<script type="text/javascript">
//<!--
function refreshblockusers2()
{
	completeAHAH.ahah('include/ajax/online.php','userblock','0','GET');
	window.setTimeout("refreshblockusers2()","10000");
}
refreshblockusers2();
//-->
</script>