<?php
/**
 * Administration functions
 * 
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}

/**
 * print editmode button
 */
function fn_admin_on_off()
{
	global $_FN,$_FNMESSAGE;
	$stout = "";
	//tasto editmode ON/OFF------------------------------->
	if ( isadmin() || can_modify($_FN['user'],"sections/{$_FN['vmod']}") )
	{
		$stout .= "<div id=\"adminonoff\" class=\"flatnukeadmin\">";
		if ( $_FN['fneditmode'] != 0 )
			$stout .= "\n<a href=\"index.php?mod={$_FN['mod']}&amp;fneditmode=0\">" . fn_i18n("_EDITMODEOFF");
		else
			$stout .= "\n<a href=\"index.php?mod={$_FN['mod']}&amp;fneditmode=1\">" . fn_i18n("_EDITMODEON");
		$stout .= "&nbsp;<img  alt=\"" . fn_i18n("_EDITMODEON") . "\" style=\"border:0px;vertical-align:middle\"src=\"" . fromtheme("images/modify.png") . "\" />";
		$stout .= "</a>";
		if (file_exists("controlcenter.php"))
		{
			$stout .= "\n&nbsp;<a href=\"{$_FN['siteurl']}controlcenter.php?mod=controlcenter\">";
			$stout .= "<img  alt=\"" . $_FNMESSAGE['CONTROLCENTER'] . "\" style=\"border:0px;vertical-align:middle\"src=\"" . fromtheme("images/configure.png") . "\" />";
			$stout .= "</a>";
		}
		$stout .= "</div>";
	}
	//tasto editmode ON/OFF-------------------------------<
	return $stout;
}

/**
 * show administration options
 *
 */
function ShowAdminOptions()
{
	global $_FN,$fnhidestructure,$_FNMESSAGE;
	//echo "";
	if ( $fnhidestructure )
		return;
	
	echo fn_admin_on_off();
	//$currentaddress = htmlspecialchars(getparam("REQUEST_URI", PAR_SERVER, SAN_FLAT));
	$getfile = getparam("file",PAR_GET,SAN_FLAT);
	$opindex = getparam("opindex",PAR_GET,SAN_FLAT);
	
	$currentaddress = "index.php?mod={$_FN['mod']}";
	if ( $getfile != "" )
		$currentaddress .= "&file=$getfile";
	
	if (  !versecid($_FN['user']) || $_FN['fneditmode'] == 0 )
		return;
	if (  !isadmin() &&  !can_modify($_FN['user'],"sections/{$_FN['vmod']}") )
		return;
	
	$mod = isset($_GET['mod']) ? $_GET['mod'] : "";
	if ( $mod == "modcont" || $opindex == "modcont" )
		return;
	
	echo "<br />";
	
	OpenTableTitle(_ADMINOPTIONS . ":");
	//---- inclusione di admin.php, opzioni amministrative riferite alla sezione   ----------------->>>>
	if ( isadmin() && $_FN['vmod'] != "" && $getfile == "" )
	{
		if ( isadmin() && (file_exists("sections/{$_FN['vmod']}/admin.php") || file_exists("sections/{$_FN['vmod']}/config.php")) )
		{
			echo "\n<div class=\"flatnukeadmin\">";
			$tmp = str_replace("none_","",$_FN['vmod']);
			$tmp = preg_replace("/^[0-9][0-9]_/i","",$tmp);
			$sectiontitle = getLang("{$_FN['vmod']}/lang.xml",$tmp);
			echo ("\n<fieldset><legend>" . _SECTIONADMINOPTIONS . " '$sectiontitle' :</legend>");
			if ( file_exists("sections/{$_FN['vmod']}/admin.php") )
			{
				include ("sections/{$_FN['vmod']}/admin.php");
			}
			if ( file_exists("sections/{$_FN['vmod']}/config.php") )
			{
				echo "<img src=\"" . fromtheme("images/configure.png") . "\" alt=\"\" />&nbsp;";
				echo "<a href=\"index.php?opindex=modcont&amp;editmode=conf&amp;file=sections/" . $_FN['vmod'] . "/config.php\">" . _EDIT_FILE_CONFIG . " '$sectiontitle'" . "</a>";
			}
			echo "\n</fieldset></div><br />";
		}
	}
	//---- inclusione di admin.php, opzioni amministrative riferite alla sezione   -----------------<<<<
	

	//--------------------------- OPZIONI PER LA HOMESECTION   ----------------->>>>
	if ( isadmin() && ($_FN['vmod'] == "" || $_FN['vmod'] == sectionlocation($_FN['home_section'])) )
	{
		echo "\n<div class=\"flatnukeadmin\">";
		echo "\n<fieldset>";
		echo "\n<legend>" . fn_i18n("_FNADMINHOMESECTION") . "</legend>";
		echo "\n<ul>";
		global $fn_datadir;
		if ( $_FN['show_welcome_message'] == 1 )
		{
			echo "\n<li><a href=\"index.php?opindex=modcont&amp;file={$_FN['datadir']}/motd.{$_FN['lang']}.php&amp;from=index.php\">".fn_i18n("_MODMOTD")."</a></li>";
		}
		//-------------------- Control Center --------------------------->
		if ( file_exists("controlcenter.php") )
		{
			echo "\n<li><a href=\"controlcenter.php\">Control center</a></li>";
		}
		//-------------------- Control Center ---------------------------<
		echo "\n<li><a href=\"index.php?mod=login&amp;op=members\">".fn_i18n("_FUTENTI")."</a></li>";
		echo "\n<li><a href=\"index.php?opindex=modcont&amp;editmode=conf&amp;file=config.php\">".fn_i18n("_EDIT_GENERAL_CONFIG")."</a></li>";
		echo "\n</ul>";
		echo "</div><br />";
	}
	//--------------------------- OPZIONI PER LA HOMESECTION   -----------------<<<<
	

	//--------------------------- opzioni amministrative riferite a tutte le sezioni  -----------------
	echo "<div class=\"flatnukeadmin\">";
	
	if ( true ) //la sezione login non va modificata
	{
		if ( $_FN['vmod'] != "" )
		{
			// --------FILE CORRENTEMENTE CARICATO------->>>>>>>>>>>>
			$currentfile = "";
			if ( file_exists("sections/" . $_FN['vmod'] . "/section.{$_FN['lang']}.html") )
			{
				$currentfile = "section.{$_FN['lang']}.html";
			}
			if ( file_exists("sections/" . $_FN['vmod'] . "/section.php") )
			{
				$currentfile = "section.php";
			}
			if ( $getfile != "" && file_exists("sections/" . $_FN['vmod'] . "/$getfile") )
			{
				$currentfile = "$getfile";
			}
			// --------FILE CORRENTEMENTE CARICATO-------<<<<<<<<<<<<
			

			//------------modifica di section.php---------------------->
			if ( can_modify($_FN['user'],"sections/{$_FN['vmod']}") && $currentfile == "section.php" )
			{
				if (  !is_writable("sections/" . $_FN['vmod'] . "/$currentfile") )
				{
					//------file in sola lettura-------
					echo "\n<pre>sections/" . $_FN['vmod'] . "/$currentfile : " . fn_i18n("_READONLY") . "</pre>";
				}
				else
				{
					echo "\n<fieldset>";
					echo "\n<legend>" . fn_i18n("_FNADMINFILESECTION") . "</legend>";
					if ( is_admin() )
					{
						echo "\n<form action='index.php' method=\"get\" ><b>section.php</b>:";
						echo "\n\t<input type='hidden' name='opindex' value='modcont' />";
						echo "\n\t<input type='hidden' name='' value='$currentaddress' />";
						echo "\n\t<input type='hidden' name='file' value='sections/" . $_FN['vmod'] . "/section.php' />";
						echo "\n\t<input type='submit'  class=\"submit\" value='" . _MODIFICA . "' />";
						echo "\n\t<input type='button' class='button' onclick=\"check('verify.php?mod=modcont&amp;file=sections/{$_FN['vmod']}/section.php&amp;delfile=1&amp;from=index.php?mod={$_FN['vmod']}');\" name=\"delfile\" value='" . _ELIMINA . "' />";
						echo "\n</form>";
					}
					if ( user_can_edit_section($_FN['vmod']) )
					{
						echo "<br /><button class=\"button\" onclick=\"window.open('filemanager.php?dir=sections/{$_FN['vmod']}/','" . "filemanager" . "','toolbar= 0,location= 0,directories= 0,status= 0,menubar= 0,scrollbars= 1,resizable= 1,width=640,height=480');\" ><img style=\"vertical-align:middle\" alt=\"filemanager\" src=\"" . fromtheme("images/mime/dir.png") . "\" />&nbsp;" . _MANAGEFILE . "</button>";
					}
					echo "\n</fieldset>";
				}
			}
			//------------modifica di section.php----------------------<
			

			//-----------------------opzioni per gli utenti che possono modificare  -------
			if ( can_modify($_FN['user'],"sections/{$_FN['vmod']}") )
			{
				//------------------file personalizzato ------------------------------>>>
				if ( $getfile != "" && can_modify_file($_FN['user'],"sections/" . $_FN['vmod'] . "/" . preg_replace('/.bak~/','',$currentfile)) && $_FN['vmod'] != "" )
				{
					if ( file_exists("sections/{$_FN['vmod']}/$getfile") )
					{
						if (  !is_writable("sections/" . $_FN['vmod'] . "/" . $getfile) )
						{
							echo "<pre>sections/" . $_FN['vmod'] . "/" . $getfile . ": " . _READONLY . "</pre>";
						}
						else
						{
							print "\n<form action=\"index.php\" method=\"get\" ><b>" . $getfile . "</b>:";
							print "\n<input type=\"hidden\" name=\"opindex\" value=\"modcont\" />";
							print "\n<input type=\"hidden\" name=\"from\" value=\"$currentaddress\" />";
							print "\n<input type=\"hidden\" name=\"file\" value=\"sections/{$_FN['vmod']}/" . $getfile . "\" />";
							if (  !preg_match('/.bak~/',$getfile) )
								print "\n<input type=\"submit\"  class=\"submit\" value=\"" . _MODIFICA . "\" />";
							else
								print "\n<input type=\"button\"  class=\"button\" onclick=\"check('verify.php?mod=restorefile&amp;filetorestore=sections/{$_FN['vmod']}/$getfile&amp;delfile=1&amp;from=index.php?mod={$_FN['vmod']}');\" name=delfile value='" . $_FNMESSAGE['RESTORE'] . "' />";
							
							if ( is_admin() ||  !preg_match('/.bak~/',$getfile) )
								print "\n<input type=\"button\"  class=\"button\" onclick=\"check('verify.php?mod=modcont&amp;file=sections/{$_FN['vmod']}/$getfile&amp;delfile=1&amp;from=index.php?mod={$_FN['vmod']}');\" name=delfile value='" . _ELIMINA . "' />";
							
							print "\n</form>";
						}
						showBKfiles($getfile);
						echo "</div>";
						CloseTableTitle();
						
						return;
					}
				}
				//------------------file personalizzato ------------------------------<<
				

				//---visualizza le opzioni per i files nelle varie lingue --->>
				if (  !is_writable("sections/{$_FN['vmod']}") )
				{
					echo "<pre>sections/" . $_FN['vmod'] . "/ : " . fn_i18n("_READONLY") . "</pre>";
				}
				else
				{
					if (  !file_exists("sections/" . $_FN['vmod'] . "/section.php") )
					{
						global $languages;
						$langs = explode(",",$languages);
						echo "<fieldset>";
						echo "<legend>" . fn_i18n("_SECTIONSTRANSLATIONS") . "</legend>";
						echo "<table border=\"0\" padding=\"0\" cellspacing=\"0\">";
						foreach ( $langs as $l )
						{
							if ( file_exists("sections/" . $_FN['vmod'] . "/section.$l.html") )
							{
								//------------section.lang.html------------------
								if (  !is_writable("sections/" . $_FN['vmod'] . "/section.$l.html") )
								{
									echo "<tr><td><pre>sections/" . $_FN['vmod'] . "/section.$l.html: " . fn_i18n("_READONLY") . "</pre></td></tr>";
								}
								else
								{
									echo "\n<tr><td><img style=\"vertical-align:middle;border:2px solid #00ff00;\" alt=\"\" border=\"0\" src=\"" . fromtheme("images/flags/$l.png") . "\" />&nbsp;&nbsp;<b>section.$l.html</b>:";
									echo "\n</td><td><form action='index.php' method=\"get\">";
									echo "\n<input type=\"hidden\" name=\"opindex\" value=\"modcont\" />";
									echo "\n<input type=\"hidden\" name=\"from\" value=\"$currentaddress\" />";
									echo "\n<input type=\"hidden\" name=\"file\" value=\"sections/" . $_FN['vmod'] . "/section.$l.html\" />";
									echo "\n<input type=\"submit\" class=\"submit\" value='" . fn_i18n("_MODIFICA") . "' />";
									echo "\n<input type=\"button\"  class=\"button\" onclick=\"check('verify.php?mod=modcont&amp;file=sections/{$_FN['vmod']}/section.$l.html&amp;delfile=1&amp;from=index.php?mod={$_FN['vmod']}');\" name=\"delfile\" value=\"" . fn_i18n("_ELIMINA") . "\" />";
									echo "\n</form></td></tr>";
								}
							}
							else
							{
								echo "\n<tr><td><img style=\"vertical-align:middle;border:2px solid #ff0000;\" alt=\"\" border=\"0\" src=" . fromtheme("images/flags/$l.png") . " />&nbsp;&nbsp;<b>section.$l.html</b>:";
								echo "\n</td><td><form action=\"verify.php\" method=\"get\">";
								echo "\n<input type=\"hidden\" value=\"createnewfile\" name=\"mod\" />";
								echo "\n<input type=\"hidden\" name=\"from\" value=\"$currentaddress\" />";
								echo "\n<input type=\"hidden\" value=\"{$_FN['vmod']}\" name=\"section\" />";
								echo "\n<input type=\"hidden\" name=\"filename\" value=\"section.$l.html\" />";
								echo "\n<input type=\"submit\" class=\"submit\" value=\"" . fn_i18n("_CREA") . "\" />";
								echo "\n</form></td></tr>";
							}
						}
						echo "</table>";
						//--------filemanager-------------->
						if ( user_can_edit_section($_FN['vmod']) )
						{
							echo "<br /><button class=\"button\" onclick=\"window.open('filemanager.php?dir=sections/{$_FN['vmod']}/','" . "filemanager" . "','toolbar= 0,location= 0,directories= 0,status= 0,menubar= 0,scrollbars= 1,resizable= 1,width=640,height=480');\" ><img style=\"vertical-align:middle\" alt=\"filemanager\" src=\"" . fromtheme("images/mime/dir.png") . "\" />&nbsp;" . fn_i18n("_MANAGEFILE") . "</button>";
						}
						//--------filemanager--------------<
						echo "</fieldset>";
					}
				}
			}
		}
		
		//backups------------>
		if ( isset($currentfile) )
			showBKfiles($currentfile);
			//backups------------<
		

		//----------------------comuni a tutte le sezioni -----------------------------
		if ( is_writable("sections/{$_FN['vmod']}/") )
		{
			if ( can_modify($_FN['user'],"sections/{$_FN['vmod']}") )
			{
				show_section_options($_FN['vmod']);
			}
		}
	}
	echo "</div>";
	//--- crea nuova sottosezione---
	if (isadmin() || (can_modify($_FN['user'],"sections/{$_FN['vmod']}") && is_writable("sections/{$_FN['vmod']}/")) )
	{
		echo "<br /><div class=\"flatnukeadmin\">";
		echo "<fieldset>";
		echo "<legend>" . fn_i18n("_FNADMINNEWSECTIONS") . "</legend>";
	}
	
	if (can_modify($_FN['user'],"sections/{$_FN['vmod']}") && is_writable("sections/{$_FN['vmod']}/")) 
	{
		if ( $_FN['mod'] != "modcont" && $_FN['vmod'] != "" ) //modcont non e' una sezione
		{
			show_create_subsection();
			echo "<hr />";
		}
	}
	//--- crea nuova sezione---
	if ( isadmin() )
	{
		if ( is_writable('sections') )
		{
			show_create_section();
		}
		else
		{
			echo "\n<h4>" . fn_i18n("_SECTIONWARNING") . "</h4>\n";
			echo "\n<h4>" . fn_i18n("_ERROR_PERM_FIX2") . "</h4>\n";
			echo "\n<pre>";
			echo "\ncd " . dirname($_SERVER['SCRIPT_FILENAME']);
			echo "\nchmod  a+w -R sections/";
			echo "\n</pre>";
		}
	}
	if (isadmin() || (can_modify($_FN['user'],"sections/{$_FN['vmod']}") && is_writable("sections/{$_FN['vmod']}/")) )
	{
		echo "</fieldset>";
		echo "</div>";
	}
	
	
	CloseTableTitle();
}

/**
 * visualizza le opzioni per creare le pagine di una nuova sezione
 *
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @param string $section percorso della sessione
 *
 **/
function show_create_file_section($sectionid)
{
	global $_FN;
	
	if ( can_modify($_FN['user'],"sections/$sectionid") )
	{
		?>
<h2><?php
		echo fn_i18n("_SECTION_EMPTY")?></h2>
<div class="flatnukeadmin">
<form method=get action="verify.php">
<ul>
	<li><?php
		echo fn_i18n("_NEW_STATIC_PAGE")?> (section.<?php
		echo $_FN['lang']?>.html)<input type="radio" checked="checked"
		value="section.<?php
		echo $_FN['lang']?>.html" name="filename" /></li>
			<?php
		
		if ( getlevel($_FN['user']) >= 10 ) //le pagine dinamiche sono solo per l'amministratore
		{
			?>
			<li><?php
			echo fn_i18n("_NEW_DYNAMIC_PAGE")?> (section.php)<input type="radio"
		value="section.php" name="filename" /></li>
				<?php
		
		}
		?></ul>
<br />
<input type="submit" class="submit" name="crea"
	value="<?php
		echo fn_i18n("_CREA")?>" /> <input type="hidden"
	value="<?php
		echo $sectionid?>" name="section" /> <input type="hidden"
	value="index.php?opindex=modcont&amp;mod=<?php
		echo $_FN['mod']?>&amp;file=<?php
		echo $sectionid?>"
	name="from" /> <input type="hidden" value="createnewfile" name="mod" />
</form>
</div>
<br />
<?php
	
	}
}
/**
 * visualizza le opzioni per creare una pagina che non esiste ancora
 *
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @param string $section percorso della sessione
 *
 **/
function show_create_file_custom($section, $filename)
{
	global $_FN;
	
	if ( can_modify_file($_FN['user'],"sections/$section/$filename") )
	{
		echo "<div class=\"flatnukeadmin\">";
		?>
<h2><?php
		echo $filename?> : <?php
		echo fn_i18n("_FILE_NOT_EXIST")?></h2>

<form method=get action="verify.php"><input type="submit" class="submit"
	name="crea" value="<?php
		echo fn_i18n("_CREA")?>" /> <input type="hidden"
	value="<?php
		echo $section?>" name="section" /> <input type="hidden"
	value="<?php
		echo $filename?>" name="filename" /> <input type="hidden"
	value="createnewfile" name="mod" /></form>
<br />
<?php
		echo "</div>";
	
	}
}
/**
 * visualizza le opzioni per creare una sottosezione che non esiste ancora
 *
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @param string $section percorso della sessione
 *
 **/
function show_create_subsection()
{
	global $_FN;
	if ( $_FN['mod'] == "modcont" || $_FN['vmod'] == "" ) //modcont non  una sezione
		return;
	$sectionname = getLang("sections/{$_FN['vmod']}/lang.xml",$_FN['vmod']);
	
	echo "<img alt=\"\"  src=\"" . fromtheme("images/subsection.png") . "\" />&nbsp;&nbsp;<b>" . fn_i18n("_SUBSECTION_CREATE") . " \"" . $sectionname . "\"</b>";
	echo "<form  method=\"post\" action=\"verify.php?mod=newsection&amp;from=index.php?mod={$_FN['vmod']}\" >";
	echo "<input type=\"hidden\" name=\"path\" value=\"{$_FN['vmod']}\" />";
	echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
	
	echo "<tr><td>" . fn_i18n("_POS") . ":</td><td><select  type=\"text\" name=\"sectionposition\" >";
	print_all_prefix("sections/{$_FN['vmod']}","");
	echo "</select>";
	echo "<td>" . fn_i18n("_TITLE") . ":&nbsp;</td><td>";
	$ll = explode(",",$_FN['languages']);
	foreach ( $ll as $llang )
	{
		echo "<nobr><input type=\"text\"  size=\"15\" name=\"sectiontitle$llang\" />";
		echo "<img style=\"vertical-align:middle\" src=\"" . fromtheme("images/flags/$llang.png") . "\" alt=\"$llang\" />";
		echo "</nobr><br />";
	}
	echo "</td><td>&nbsp;<input type=\"submit\" class=\"submit\" name=\"newdir\" value=\"" . fn_i18n("_CREA") . "\" />";
	echo "</tr></table>";
	echo "</form>";
}

/**
 * visualizza le opzioni per creare una sezione che non esiste ancora
 *
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @param string $section percorso della sessione
 *
 **/
function show_create_section()
{
	global $_FN;
	
	if ( $_FN['mod'] == "modcont" || ($_FN['vmod'] == "" && sectionlocation($_FN['home_section']) != "") ) //modcont non  una sezione
		return;
	
	echo "<img alt=\"\"  src=\"" . fromtheme("images/section.png") . "\" />&nbsp;&nbsp;<b>" . fn_i18n("_SECTION_CREATE") . "</b>";
	echo "<form  method=\"post\" action=\"verify.php?mod=newsection&amp;from=index.php?mod={$_FN['vmod']}\" >";
	echo "<input type=\"hidden\" name=\"path\" value=\"\" />";
	echo "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
	
	echo "<tr><td>" . fn_i18n("_POS") . ":</td><td><select  type=\"text\" name=\"sectionposition\" >";
	print_all_prefix("sections/","");
	echo "</select>";
	echo "<td>" . fn_i18n("_TITLE") . ":&nbsp;</td><td>";
	$ll = explode(",",$_FN['languages']);
	foreach ( $ll as $llang )
	{
		echo "<nobr><input type=\"text\"  size=\"15\" name=\"sectiontitle$llang\" />";
		echo "<img style=\"vertical-align:middle\" src=\"" . fromtheme("images/flags/$llang.png") . "\" alt=\"$llang\" />";
		echo "</nobr><br />";
	}
	echo "</td><td>&nbsp;<input type=\"submit\" class=\"submit\" name=\"newdir\" value=\"" . fn_i18n("_CREA") . "\" />";
	echo "</tr></table>";
	echo "</form>";
}

/**
 * show change title,rename,move
 *
 * @param unknown_type $section
 */
function show_section_options($section)
{
	global $languages,$_FNMESSAGE,$_FN;
	
	if ( $_FN['vmod'] == "" )
		return;
		
	//-----CAMBIO TITOLO E POSIZIONE------>>>>>>>>>
	if ( can_modify($_FN['user'],"sections/" . $section) )
	{
		$handle = opendir("sections/$section/");
		$empty = true;
		while (false !== ($file = readdir($handle)))
		{
			if ( $file != "." and $file != ".." and is_dir("sections/$section/$file") == true )
				$empty = false;
		}
		closedir($handle);
		//form per il cambio del titolo nella lingua corrante
		if ( is_writable("sections/$section/") )
		{
			//die ($section);
			echo "\n<fieldset>";
			echo "\n<legend>" . fn_i18n("_SECTION_RENAME") . "</legend>";
			$tmp = preg_replace("/^[0-9]+_|^none_/si","",basename($section));
			$sectionprefix = str_replace("_$tmp","",basename($section));
			$sectionpath = preg_replace("/" . basename($section) . '$/s',"",$section);
			echo "<form method=\"post\" action=\"verify.php?mod=changesectiontitle&amp;from=index.php?mod=$section\" >";
			echo "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr>";
			echo "<td>" . fn_i18n("_POS") . ":";
			echo "<select name=\"pos\" >";
			print_all_prefix("sections/$sectionpath",$sectionprefix);
			echo "</select></td><td>";
			$langs = explode(",",$languages);
			echo "<td>" . fn_i18n("_TITLE") . ":</td><td>";
			foreach ( $langs as $llang )
			{
				$text = getLang("sections/$section/lang.xml","",$llang,"UTF-8");
				if ( $text != "" )
				{
					
					$oUnicodeReplace = new unicode_replace_entities();
					$text = $oUnicodeReplace->UTF8entities($text);
					$text = str_replace("'","&#039;",$text);
					$text = str_replace('"',"&quot;",$text);
				
				}
				//$text = html_entity_decode($text,ENT_COMPAT,'ISO-8859-1');
				

				echo "\n<nobr><input title=\"" . fn_i18n("_TITLE") . ":$llang\" type=\"text\" size=\"15\" name=\"sectiontitle_$llang\"  value=\"" . $text . "\" />";
				echo "\n<img  border=\"0\" src=\"" . fromtheme("images/flags/$llang.png") . "\" alt=\"$llang\" /></nobr><br />";
			}
			echo "</td><td>&nbsp;<input type=\"submit\" class=\"submit\" value=\"" . fn_i18n("_SAVE") . "\" /></td></tr></table>";
			
			echo "<input type=\"hidden\" name=\"sectionname\" value=\"" . htmlentities("sections/$section") . "\" />";
			//------------sposta----------------------->
			echo "<br />{$_FNMESSAGE ['moveto']}:<select name=\"newpath\">";
			$sections = list_sections_translated("sections",true,true);
			if ( can_modify($_FN['user'],"sections/" . sectionlocation($_FN['home_section'])) )
				echo "<option value=\"\" />" . $_FN['sitename'] . "</option>";
			
			foreach ( $sections as $section )
			{
				$s = "";
				if ( $section['link'] == dirname($_FN['vmod']) )
				{
					$s = "selected=\"selected\"";
				}
				if (  !preg_match('/^' . $_FN['vmod'] . '/',$section['link']) &&  !preg_match('/^none_Control_Center/',$section['link']) )
				{
					$spaces = "";
					$nspaces = explode('/',$section['link']);
					for ( $x = 0;$x < count($nspaces);$x++  )
					{
						$spaces .= "&nbsp;&nbsp;";
					}
					if ( can_modify($_FN['user'],"sections/{$section['link']}") )
					{
						echo "<option $s value=\"" . $section['link'] . "\" />$spaces" . get_section_title($section['link']) . "</option>";
					}
				}
			}
			echo "</select>.";
			//------------sposta-----------------------<
			echo "<input type=\"submit\" class=\"submit\" value=\"" . fn_i18n("_FNMOVESECTION") . "\" />";
			echo "</form>";
			echo "\n</fieldset><br />";
		}
	}
	//-----CAMBIO TITOLO E POSIZIONE ------<<<<<<<<<<<			
	

	//-----cambio permessi, solo amministratore ------>>>>>>>>>
	define("_MAX_USERS_ADMIN",100);
	if ( isadmin() )
	{
		if ( sectionlocation("login") != $_FN['vmod'] )
		{
			echo "<fieldset>";
			echo "<legend>" . fn_i18n("_PERMS") . "</legend>";
			
			//form per cambio livello della sezione
			$perm = getsectperm("sections/" . $_FN['vmod']);
			$users = get_userlist();
			$groups = get_grouplist();
			
			print("<form action='verify.php' method='post'>");
			echo "<table border=\"0\" padding=\"0\" cellspacing=\"0\">";
			echo "<tr>";
			//permssi modifica
			echo "<td><b>" . fn_i18n("_FNEDITPERMS") . ":</b>&nbsp;&nbsp;</td>";
			print("<td>&nbsp;" . fn_i18n("_FUTENTE") . ": ");
			
			if ( count($users) < _MAX_USERS_ADMIN )
			{
				print("<select name='user'>");
				print("<option value=''>" . fn_i18n("_FNNONE") . "</option>");
				foreach ( $users as $user )
				{
					if ( $perm['user'] == $user )
						print("<option value='$user' selected=\"true\" >$user</option>");
					else
						print("<option value='$user' >$user</option>");
				}
				print("</select>");
			}
			else
			{
				echo "<input size=\"20\" name=\"user\" value=\"{$perm['user']}\" />";
			}
			echo "</td><td>";
			print("" . fn_i18n("_GRUPPO") . ": </td><td>");
			print("<select name='group'>");
			print("<option value=''>" . fn_i18n("_FNNONE") . "</option>");
			foreach ( $groups as $group )
			{
				if ( $perm['group'] == $group )
					print("<option value='$group' selected=\"true\" >$group</option>");
				else
					print("<option value='$group' >$group</option>");
			}
			print("</select></td></tr>");
			
			//permssi visione
			echo "<tr><td><b>" . fn_i18n("_FNVIEWPERMS") . ":</b>&nbsp;&nbsp;</td>";
			print("<td>&nbsp;" . fn_i18n("_FUTENTE") . ": ");
			
			if ( count($users) < _MAX_USERS_ADMIN )
			{
				print("<select name='user_view'>");
				print("<option value=''>" . fn_i18n("_FNALL") . "</option>");
				//$users = get_userlist();
				foreach ( $users as $user )
				{
					if ( $perm['user_view'] == $user )
						print("<option value='$user' selected=\"true\" >$user</option>");
					else
						print("<option value='$user' >$user</option>");
				}
				print("</select>");
			}
			else
			{
				echo "<input size=\"20\" name=\"user_view\" value=\"{$perm['user_view']}\" />";
			}
			print("</td><td>" . fn_i18n("_GRUPPO") . ": </td><td>");
			
			print("<select name='group_view'>");
			print("<option value=''>" . fn_i18n("_FNALL") . "</option>");
			foreach ( $groups as $group )
			{
				if ( $perm['group_view'] == $group )
					print("<option value='$group' selected=\"true\" >$group</option>");
				else
					print("<option value='$group' >$group</option>");
			}
			echo "</select>";
			
			echo "</td></tr>";
			echo "<tr><td colspan=\"2\"><b>" . fn_i18n("_PERMVIEW") . "</b>&nbsp";
			print("<input type='hidden' name='mod' value='modlevel' />");
			print("<input type='hidden' name='section' value='" . $_FN['vmod'] . "' /></td>");
			print("<td>" . fn_i18n("_LEVEL") . ": </td><td>");
			print("<select name='level'>");
			print("<option value='-1'>---</option>");
			for ( $i = 0;$i < 11;$i++  )
			{
				if ( $perm['level'] == $i )
					print("<option value='$i' selected=\"selected\" >$i</option>");
				else
					print("<option value='$i' >$i</option>");
			}
			print("</select>");
			
			print("</td>");
			print("</tr>");
			echo "</table>";
			echo "<input type='submit' class=\"submit\" value='" . fn_i18n("_SAVE") . "' />";
			echo "</form></fieldset><br />";
		}
		//dprint_r($perm);
	}
	//-----cambio permessi, solo amministratore ------<<<<<<<<<
	//--------form per la cancellazione della sezione------->>>>>>
	//dprint_r($section);
	if ( is_writable("sections/{$_FN['vmod']}/") )
	{
		echo "<fieldset>";
		?>

<legend><?php
		echo fn_i18n("_ELIMINA")?></legend>
<img alt="" border="0"
	src="<?php
		echo fromtheme("images/delete.png")?>" />
<?php
		if ( $empty != true )
		{
			echo fn_i18n("_SECTIONISNOTEMPTY") . "<br /><br />";
		}
		else
		{
			?>
		&nbsp;
<b><?php
			echo fn_i18n("_SECTION_DELETE")?></b>
<input
	onclick="check('verify.php?mod=delsection&#038;sectionname=<?php
			echo $_FN['vmod']?>');"
	type="button" class="button" name="newdir"
	value="<?php
			echo fn_i18n("_EXECUTE")?>" />
<?php
		}
		echo "</fieldset><br />";
	}
	//--------form per la cancellazione della sezione-------<<<<<?php


}
/**
 * print all section prefix 
 *
 * @param string $where
 * @param string $selected
 */
function print_all_prefix($where, $selected)
{
	global $_FNMESSAGE;
	$ret = $ret_sect = array();
	if ( file_exists($where) && is_dir($where) )
	{
		$all = list_sections_translated($where);
		foreach ( $all as $item )
		{
			if ( $item['prefix'] != "none" )
			{
				$ret[] = $item['prefix'];
				$ret_sect[$item['prefix']] = $item;
			}
		}
	}
	
	echo "\n<option value=\"none\">" . $_FNMESSAGE['hidden'] . "</option>";
	for ( $i = 0;$i < 100;$i++  )
	{
		$p = $i;
		if ( $p < 10 )
		{
			$p = "0$p";
		}
		//cerca la prima libera
		if ( $selected == "" &&  !in_array($p,$ret) )
			$selected = $p;
		if ( $selected == $p )
			echo "\n<option selected=\"selected\" value=\"$p\">$i</option>";
		else
		{
			if (  !in_array($p,$ret) )
			{
				echo "\n<option value=\"$p\">$i</option>";
			}
			else
			{
				$b = "[" . $ret_sect[$p]['title'] . "]";
				echo "\n<option disabled=\"disabled\" value=\"$p\">$i $b</option>";
			
			}
		}
	}

}
/**
 * show backups files
 *
 * @param string $filetobk
 */
function showBKfiles($filetobk = "")
{
	global $_FN,$_FNMESSAGE;
	global $forumback,$forumborder;
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "style=\"background-color:#$forumborder\" cellspacing=\"1\" cellpadding=\"2\"";
	if ( $forumback != "" )
		$fbackground = "style=\"background-color:#$forumback\"";
		
	//------------Restore-------------->>
	$handle = opendir("sections/{$_FN['vmod']}");
	$files = array();
	while (false !== ($file = readdir($handle)))
	{
		if ( preg_match('/.bak~$/',$file) &&  !is_dir("sections/{$_FN['vmod']}/$file") )
		{
			if ( $filetobk == "" || preg_match('/^' . $filetobk . "./",$file) )
			{
				$files[] = $file;
			}
		}
	}
	closedir($handle);
	sort($files);
	$filebklist = array();
	foreach ( $files as $file )
	{
		
		preg_match("/(.*)\\.([0-9]+)\\.(.*)\\.(bak~)/",$file,$fileinfo);
		//dprint_r($fileinfo);
		//$fileinfo = explode(".",$file);
		$userm = $fileinfo[3];
		$ori = $fileinfo[1];
		if ( can_modify_file($_FN['user'],"sections/{$_FN['vmod']}/$ori") )
		{
			$fbk['originalname'] = $ori;
			$fbk['date'] = fn_GetDateTime($fileinfo[2]);
			$fbk['user'] = $userm;
			$fbk['backup_name'] = $file;
			array_push($filebklist,$fbk);
		}
	}
	
	if ( count($filebklist) == 0 )
		return;
	echo "<fieldset>";
	echo "<legend>Backups</legend>";
	echo "<table $fbackborder >";
	
	echo "<tr><td $fbackground>File:</td><td $fbackground>" . _NOMEUTENTE . ":</td><td $fbackground>" . _DATA . ":</td><td $fbackground>&nbsp;</td><td $fbackground>&nbsp;</td></tr>";
	foreach ( $filebklist as $fbk )
	{
		
		$userm = $fbk['user'];
		$datem = $fbk['date'];
		$ori = $fbk['originalname'];
		$filebk = $fbk['backup_name'];
		echo "<tr>";
		echo "<td $fbackground>";
		echo "<a href=\"?mod={$_FN['mod']}&amp;file=$filebk\" >$ori</a>";
		echo "</td>";
		echo "<td $fbackground>";
		echo "<a href=\"?mod={$_FN['mod']}&amp;file=$filebk\" >$userm</a>";
		echo "</td>";
		echo "<td $fbackground>";
		echo "<a href=\"?mod={$_FN['mod']}&amp;file=$filebk\" >$datem</a>";
		echo "</td>";
		echo "<td $fbackground>";
		echo "<a href=\"javascript:check('verify.php?mod=restorefile&from=index.php?mod={$_FN['mod']}&filetorestore=sections/{$_FN['vmod']}/$filebk')\" >" . $_FNMESSAGE['RESTORE'] . "</a>";
		echo "</td>";
		echo "<td $fbackground>";
		if ( is_admin() )
			echo "<a href=\"javascript:check('verify.php?mod=modcont&delfile=1&file=sections/{$_FN['vmod']}/$filebk&from=index.php?mod={$_FN['mod']}');\" >" . _ELIMINA . "</a>";
		else
			echo "&nbsp;";
		echo "</td>";
		echo "</tr>";
	
	}
	echo "</table>";
	echo "</fieldset>";
	//------------Restore--------------


}

?>