<?php
/**
 * Editor functions 
 *
 * @package Flatnux_functions
 * 
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
/**
 * Edit content with textarea or editor
 * 
 * @param string $filename
 * @param string $from
 */
function edit_content($filename, $from = false)
{
	global $_FN;
	$htmleditor = $_FN['htmleditor'];
	$editmodeg = getparam("editmode", PAR_GET, SAN_FLAT);
	$editmodep = getparam("editmode", PAR_POST, SAN_FLAT);
	if ( stristr($filename, "..") )
		die(fn_i18n("_NONPUOI"));
	if ( !file_exists($filename) )
	{
		echo "file non exists";
		return;
	}
	if ( $editmodep == "conf" )
	{
		fn_editconffile($filename);
		return;
	}
	if ( $editmodeg == "conf" )
	{
		fn_editconffile($filename, $from);
		return;
	}
	if ( !can_modify_file($_FN['user'], $filename) )
		return;
	$ishtml = ($htmleditor != "0" && (strstr($filename, "motd.") || get_file_extension($filename) == "html") || get_file_extension($filename) == "htm");
	// se ho inserito del php non posso usare l' editor html
	if ( $ishtml && strstr(file_get_contents($filename), "<?") )
		$ishtml = 0;
	//se e' un file html e ho l' html abilitato faccio eseguo edit_content_html
	if ( $ishtml )
	{
		$customeditor = getparam("editor", PAR_GET, SAN_FLAT);
		if ( $customeditor != "" && file_exists("include/extra/$customeditor/htmlarea.php") )
			$htmleditor = $customeditor;
		if ( $htmleditor != "0" && can_modify_file($_FN['user'], $filename) && versecid($_FN['user']) )
		{
			if ( file_exists("include/extra/$htmleditor/htmlarea.php") )
			{
				require_once ("include/extra/$htmleditor/htmlarea.php");
				if ( !function_exists("showhtmlarea") )
				{
					echo "$htmleditor " . fn_i18n("_FERROREDITOR");
					require_once ("include/extra/textarea/htmlarea.php");
				}
			}
			else
			{
				echo "$htmleditor " . fn_i18n("_FERROREDITOR");
				if ( file_exists("include/extra/textarea/htmlarea.php") )
				{
					require_once ("include/extra/textarea/htmlarea.php");
				}
			}
		}
	}
	if ( $from == false )
		$from = isset($_GET['from']) ? $_GET['from'] : getparam("HTTP_REFERER", PAR_SERVER, SAN_FLAT);

	if ( get_file_extension($filename) == "menu" )
	{
		OpenTableTitle(fn_i18n("_MODIFICA") . " " . $filename);
		echo "<form action='verify.php' method='post' >";
		echo "<input type='hidden' name='mod' value='modcont' />";
		echo "<input type='hidden' name='file' value='" . $filename . "' />";
		/*
		$values = explode(",",file_get_contents($filename));
		////(0$path, 1$menu_recursive, 2$show_icons, 3$menu_recursive_onlyselected)
		echo "Path: <input type=\"text\" id=\"path\" value=\"".$values[0]."\" />";
		echo "Separator: <input type=\"text\" value=\"".$values[4]."\" />";
		$c = empty($values[1])?"":"checked=checked";
		echo "<input $c type=\"checkbox\" id=\"menu_recursive\" value=\"1\" />Recursive&nbsp;";
		$c = empty($values[2])?"":"checked=checked";
		echo "<input $c type=\"checkbox\" id=\"menu_recursive_onlyselected\" value=\"1\" />Recursive only current section&nbsp;";
		$c = empty($values[3])?"":"checked=checked";
		echo "<input $c type=\"checkbox\" id=\"show_icons\" value=\"1\" />Show icons&nbsp;";

echo "<script>
updatemenuvalues = function() {
document.getElementById('menuvalues').value=document.getElementById('path').value+
','+document.getElementById('menuvalues').value=document.getElementById('path').checked+

}
</script>

";*/
		echo "<input type='text' id=\"menuvalues\" name='body' value='" . htmlspecialchars(file_get_contents($filename)) . "' />";

		if ( !is_writable($filename) )
			echo fn_i18n("_READONLY");
		echo "<button type=\"submit\"  class=\"submit\">" . fn_i18n("_SAVE") . "</button>";
		echo "&nbsp;<input type='button' class='button' onclick='window.location=(\"$from\")'  value='" . fn_i18n("_CANCEL") . "' />
		</form>";
		CloseTableTitle();
	}
	else
	{
		OpenTableTitle(fn_i18n("_MODIFICA") . " " . $filename);
		echo "<form action='verify.php' method='post' >";
		echo "<input type='hidden' name='mod' value='modcont' />
<input type='hidden' name='from' value='" . $from . "' />";
		if ( $ishtml && function_exists("showhtmlarea") )
		{
			echo "<br /><br />
<input type='hidden' name='file' value='" . $filename . "' />
<input type='hidden' name='linktolocal' value='" . $filename . "' />";
			$text = local_to_abs($filename);
			showhtmlarea("body", "", 30, $text, dirname($filename));
			echo "<br /><br />";
			//dprint_xml($text);
		}
		else
		{
			echo "\n<textarea wrap=\"OFF\" cols='80' rows='30' id='body' name='body' style='FONT-FAMILY:monospace,\"Courier New\", Courier ;font-size:13px;'>";
			echo htmlspecialchars(file_get_contents($filename));
			echo "\n</textarea><br /><br />";
			if ( $_FN['syntax_highlighting'] == "1" )
			{
				$lhl = strtolower(get_file_extension($filename));
				if ( $lhl !== "php" && $lhl !== "sql" && $lhl !== "js" && $lhl !== "html" && $lhl !== "xhtml" && $lhl !== "xml" && $lhl !== "css" )
					$lhl = "text";
				if ( $lhl == "xml" || $lhl == "xhtml" || $lhl == "htm" )
					$lhl = "html";
				if ( $lhl == "js" )
					$lhl = "javascript";
				echo "\n<script type=\"text/javascript\" src=\"include/codepress/codepress.js\" ></script>";
				echo "<script type=\"text/javascript\" >
codepressReplaceTextarea(\"include/codepress/\",\"body\",\"$lhl\");
</script>
";
			}
		}
		echo "<input type='hidden' name='file' value='" . $filename . "' />";
		if ( !is_writable($filename) )
			echo fn_i18n("_READONLY");
		echo "<button type=\"submit\"  class=\"submit\">" . fn_i18n("_SAVE") . "</button>";
		echo "&nbsp;<input type='button' class='button' onclick='window.location=(\"$from\")'  value='" . fn_i18n("_CANCEL") . "' />
</form>";
		CloseTableTitle();
	}
}
/**
 * Estrae i file di configurazione e li stampa a video per la modifica.
 *
 * Esempio formattazione:
 * #[it]Titolo in italiano {opzione1=1,opzione2=2}
 * #[en]Title 2 in english 
 * $nomevariabile // {string}
 * #[it]Titolo 2 in italiano 
 * #[en]Title 2 in english 
 * $nomevariabile2 // {color}
 *
 * @param   string  $file      nome del file
 */
/**
 * Edit config file
 * 
 * Sample:
 * #[it]Titolo in italiano {opzione1=1,opzione2=2}
 * #[en]Title 2 in english 
 * $nomevariabile // {string}
 * #[it]Titolo 2 in italiano 
 * #[en]Title 2 in english 
 * $nomevariabile2 // {color}
 * 
 * 
 * @param string $file
 * @param string $from
 */
function fn_editconffile($file, $from = false)
{
	global $_FN;
	$lang = $_FN['lang'];
	OpenTableTitle(fn_i18n("_MODIFICA") . " " . $file);
	if ( !file_exists($file) ) // controllo che il file esista prima di fare qualsiasi operazione
		return;
	if ( $from == false )
	{
		$from = isset($_GET['from']) ? $_GET['from'] : getparam("HTTP_REFERER", PAR_SERVER, SAN_FLAT);
		if ( $from == "" )
			$from = "index.php";
	}
	echo "
<script language=\"javascript\">
var synccheck = function (id)
{
	//alert('checkconf' + id);
	var divitems = document.getElementById('checkconf' + id ).childNodes;
	var sep='';
	var str='';
	for (var i in divitems)
	{
		items=divitems[i].childNodes
		for (var i in items)
		{
			if (items[i].checked == true )
			{
				str = str+ sep + items[i].name
				sep=',';
			}
		}
	}
	document.getElementsByName('conf_value'+id)[0].value=str;

}
var moveup = function (node)
{
	var newnode=node;
	var parent=node.parentNode;
	var prevnode=node.previousSibling;
	parent.removeChild(node);
	parent.insertBefore(newnode,prevnode);
	//alert(mewelem);
}
var movedown = function (node)
{
	var newnode;
	var parent;
	var nextnode;
	newnode = node;
	parent = node.parentNode
	if (node.nextSibling != undefined)
		nextnode = node.nextSibling.nextSibling;
	else
		nextnode = parent.firstChild;

	if (node.nextSibling != null)
	{
		parent.removeChild(node);
		parent.insertBefore(newnode,nextnode);
	}
}
</script>

<!-- lista dei campi da modificare in textfields -->
<form action=\"verify.php\" method=\"post\"><input type=\"hidden\" name=\"mod\"
	value=\"modconfig\" /> <input type=\"hidden\" name=\"conf_file\"
	value=\"$file\" /> <!-- nome file di configurazione da modificare --> <input
	type=\"hidden\" name=\"from\" value=\"$from\" />
<table border=\"0\" cellpadding=\"1\" cellspacing=\"0\">
	<tbody>
";
	$ffile = $file;
	$fg = file($file);
	$j = 0;
	// scansione file alla ricerca delle variabili
	for ( $i = 0; $i < count($fg); $i++ )
	{
		if ( preg_match('/^\$./s', $fg[$i]) && strpos($fg[$i], "Array();") === false ) // prende solo le righe che iniziano col carattere "$"
		{
			//$line_tmp = explode("=", $fg[$i]); // cancella eventuali commenti a dx della variabile
			$line_tmp1 = explode("=", $fg[$i]);
			unset($line_tmp1[0]);
			$line_tmp1 = implode("=", $line_tmp1);
			$varvalue = "";
			eval('$varvalue=' . $line_tmp1);
			$line_tmp = explode(";", $fg[$i]); // cancella eventuali commenti a dx della variabile
			$type = "";
			$onchange = "";
			$inputsize = 30;
			//ricavo il tipo di campo -->
			if ( isset($line_tmp[1]) )
				preg_match('/[\{].+[\}]/i', $line_tmp[1], $type);
			if ( isset($type[0]) )
				$type = trim($type[0]);
			else
				$type = "";
			if ( $type == "{color}" )
			{
				$inputsize = 20;
				$onchange = "onchange='try{document.getElementById(\"cc_conf_$i\").style.backgroundColor=\"#\"+this.value}catch(e){}'";
			}
			//echo "<br />t=$type";
			//ricavo il tipo di campo <--
			$line = explode("=", $line_tmp[0]); // separa variabile e valorizzazione
			$title = "";
			$options = false;
			// cerca il titolo tradotto, se non esiste usa il primo oppure il nome della variabile 
			$find = 1;
			$exists = false;
			while ( preg_match('/^#./s', $fg[$i - $find]) && !($exists = preg_match('/^#\[' . $lang . '\]./s', $fg[$i - $find])) )
			{
				$find++;
			}
			if ( !$exists )
				$find = 1;
			if ( preg_match('/^#./s', $fg[$i - $find]) )
			{
				$title = preg_replace('/^#/s', "", $fg[$i - $find]);
				$t = "";
				preg_match('/[\{].+[\}]/i', $title, $t);
				if ( isset($t[0]) )
				{
					$options = explode(',', str_replace("{", "", str_replace("}", "", $t[0])));
				}
			}
			if ( preg_match('/^\\/\\/./s', $fg[$i - 1]) )
			{
				$title = preg_replace('/^\\/\\//s', "", $fg[$i - 1]);
			}
			$title = preg_replace('/\{.+\}/s', '', $title);
			$title = preg_replace('/\[' . $lang . ']/s', '', $title);
			$title = htmlentities(trim($title));
			$varname = htmlentities(ucfirst(str_replace("_", " ", trim(preg_replace('/^\$/s', '', $line[0])))));
			if ( $title == "" )
				$title = $varname;
			echo "<tr><td style=\"border-bottom:1px dotted #dadada;text-align:left;\">";
			echo "\n<b>$title:</b><input type=\"hidden\" name=\"conf_field$j\" value=\"{$line[0]}\" />";
			echo "</td><td style=\"border-bottom:1px dotted #dadada;text-align:left;\">";
			if ( !$options )
			{
				$ttype = "text";
				if ( fn_ergi("password", $varname) || $type == "{password}" )
					$ttype = "password";
				echo "<input title=\"$varname\" $onchange type=\"$ttype\" name=\"conf_value$j\" size=\"$inputsize\" maxlength=\"1200\" value=\"" . htmlentities($varvalue) . "\" />";
			}
			else
			{
				//---------checkbox----------------------->
				if ( $options[0][0] == "+" )
				{
					$allopt = array();
					$dirtoopen = $options[0];
					$dirtoopen = str_replace("+", "", $dirtoopen);
					echo "<input type=\"hidden\" value=\"" . htmlentities($varvalue) . "\" name=\"conf_value$j\"  />";
					$is_file = false;
					if ( preg_match('/.php$/s', $dirtoopen) )
					{
						$allfiles = glob(preg_replace('/^\$fn_datadir\\//s', $_FN['datadir'] . "/", $dirtoopen));
						foreach ( $allfiles as $filename )
						{
							$allopt[] = preg_replace('/.php$/s', '', basename($filename));
						}
						$is_file = true;
					}
					if ( is_dir($dirtoopen) )
					{
						$allopt = list_sections($dirtoopen);
					}
					if ( $is_file )
						$dirtoopen = preg_replace('/\*.php$/s', '', $dirtoopen);
					echo "<div id=\"checkconf$j\">";
					$enabledopt = explode(",", $varvalue);
					$disabledopt = array_diff($allopt, $enabledopt);
					foreach ( $enabledopt as $opt )
					{
						if ( $opt == "" )
							continue;
						if ( $is_file )
							$title = getLang($dirtoopen . "/$opt.php.xml", $opt);
						else
							$title = getLang($dirtoopen . "/$opt/lang.xml", $opt);
						echo "<div>";
						echo "<a href=\"javascript:;\" onclick=\"moveup(this.parentNode);\">";
						echo "<img style=\"vertical-align:middle;border:0px;\" src=\"" . fromtheme("images/icons/up.png") . "\" title=\"" . _MOVEUP . "\" /></a>";
						echo "<a href=\"javascript:;\" onclick=\"movedown(this.parentNode);\">";
						echo "<img style=\"vertical-align:middle;border:0px;\" src=\"" . fromtheme("images/icons/down.png") . "\" title=\"" . _MOVEDOWN . "\" /></a>";
						echo "&nbsp;&nbsp;$title<input name=\"$opt\" onclick=\"synccheck('$j');\" checked=\"checked\" type=\"checkbox\" />";
						echo "</div>";
					}
					foreach ( $disabledopt as $opt )
					{
						if ( $is_file )
							$title = getLang($dirtoopen . "/$opt.php.xml", $opt);
						else
							$title = getLang($dirtoopen . "/$opt/lang.xml", $opt);
						echo "<div>";
						echo "<a href=\"javascript:;\" onclick=\"moveup(this.parentNode);\">";
						echo "<img style=\"vertical-align:middle;border:0px;\" src=\"" . fromtheme("images/icons/up.png") . "\" title=\"" . _MOVEUP . "\" /></a>";
						echo "<a href=\"javascript:;\" onclick=\"movedown(this.parentNode);\">";
						echo "<img style=\"vertical-align:middle;border:0px;\" src=\"" . fromtheme("images/icons/down.png") . "\" title=\"" . _MOVEDOWN . "\" /></a>";
						echo "&nbsp;&nbsp;$title<input name=\"$opt\" onclick=\"synccheck('$j');\"  type=\"checkbox\" />";
						echo "</div>";
					}
					echo "</div>";
				}
				//---------checkbox-----------------------<
				else
				{
					$onchange = "";
					$thumbimgselected = "";
					$havethumb = false;
					$script = "onchange=\"this.options[this.selectedIndex].onfocus()\"";
					$script .= " onkeyup=\"this.options[this.selectedIndex].onfocus()\"";
					$divid = "conf_$i";
					echo "<select $script $onchange name=\"conf_value$j\"  >";
					$script = "document.getElementById('$divid').innerHTML = '" . addslashes("") . "'";
					foreach ( $options as $val )
					{
						$valdesc = trim($val);
						if ( preg_match("/=/s", $valdesc) )
						{
							$t = explode("=", $valdesc);
							$val = trim($t[0]);
							$valdesc = trim($t[1]);
							$s = ($val == trim($line[1], "\" ")) ? "selected=\"selected\"" : "";
							echo "<option onfocus=\"$script\" $s value=\"$val\">$valdesc</option>";
						}
						else
						{
							$cdir = $valdesc;
							if ( preg_match('/.php$/s', $cdir) )
							{
								$files = glob(preg_replace('/^\\$fn_datadir\\//s', $_FN['datadir'] . "/", $valdesc));
								foreach ( $files as $cf )
								{
									//if (file_exists($cf.".xml"))
									$sv = preg_replace('/.php$/s', '', basename($cf));
									//----immagini ---->
									$thumbimg = "";
									$thumb = "$cf.png";
									if ( file_exists($thumb) )
									{
										$thumbimg = "<img style='vertical-align:middle' src='$thumb' />";
										$script = "document.getElementById('$divid').innerHTML = '" . addslashes($thumbimg) . "'";
										$havethumb = true;
									}
									else
									{
										$script = "document.getElementById('$divid').innerHTML = ''";
									}
									//----immagini ----<
									$ticf = getLang($cf . ".xml", "");
									$s = ($sv == trim($line[1], "\" ")) ? "selected=\"selected\"" : "";
									if ( $s )
										$thumbimgselected = $thumbimg;
									echo "\n<option onfocus=\"$script\" $s value=\"$sv\">";
									if ( $ticf != "" )
										echo "$ticf [$sv]";
									else
										echo "$sv";
									echo "</option>";
								}
							}
							else
							if ( is_dir($cdir) )
							{
								$handle = opendir($cdir);
								$options = array();
								while ( false !== $file = readdir($handle) )
								{
									$val1 = "";
									if ( $file != "." && $file != ".." && is_dir($cdir . "/" . $file) )
									{
										//----immagini ---->
										$thumbimg = "";
										$thumb = $cdir . "/" . $file . "/screenshot.png";
										if ( !file_exists($thumb) )
											$thumb = $cdir . "/" . $file . "/thumb.png";
										if ( !file_exists($thumb) )
											$thumb = $cdir . "/" . $file . "/icon.png";
										if ( file_exists($thumb) )
										{
											$thumbimg = "<img style='vertical-align:middle' src='$thumb' />";
											$script = "document.getElementById('$divid').innerHTML = '" . addslashes($thumbimg) . "'";
											$havethumb = true;
										}
										else
										{
											$script = "document.getElementById('$divid').innerHTML = ''";
										}
										//----immagini ----<
										if ( preg_match('/^\\.\\/sections$/s', $cdir) || preg_match('/^\\.\\/sections\\//s', $cdir) )
										{
											$val = get_section_id("$file");
											$val1 = $file;
										}
										else
										{
											$val = $file;
										}
										$valdesc = getLang($cdir . "/" . $file . "/lang.xml", $file);
										$s = "";
										if ( $val == trim($line[1], "\" ") )
										{
											$thumbimgselected = $thumbimg;
											$s = "selected=\"selected\"";
										}
										if ( $val1 != "" && $s == "" )
										{
											if ( $val1 == trim($line[1], "\" ") )
											{
												$s = "selected=\"selected\"";
												$thumbimgselected = $thumbimg;
											}
										}
										$scopt = " onfocus = \"$script\" ";
										echo "\n\t<option $scopt $s value=\"$val\">$valdesc</option>";
									}
								}
								closedir($handle);
							}
						}
					}
					echo "</select>";
					//if ( $havethumb )
					echo "<div style=\"\" id=\"$divid\">$thumbimgselected</div>";
				}
			}
			$v = trim($line[1], "\" ");
			if ( $type == "{color}" )
			{
				echo "<span id=\"cc_conf_$i\" style=\"border:#000000 1px solid;background-color:#$v\">&nbsp;&nbsp;&nbsp;&nbsp;</span>";
			}
?>
			<input type="hidden" name="conf_value_old<?php echo $j ?>"
				   value="<?php echo htmlentities($varvalue) ?>" />
			</td>
			</tr>
<?php
			$j++;
		}
	}
?>
	<tr>
		<td colspan="2"><input type="button" class="button" name="prev"
							   onclick='window.location=("<?php echo $from ?>")'
							   value="<?php echo fn_i18n("_CANCEL") ?>" />
						   <?php
						   if ( is_writable($ffile) )
						   {
						   ?>
			<input type="submit" class="submit" name="save"
				   value="<?php echo fn_i18n("_SAVE") ?>" />
			   <?php
						   }
						   else
						   {
							   echo fn_i18n("_READONLY");
						   }
			   ?>
				</td>
                        </tr>
			</tbody>
			</table>
			<br />
			<input type="hidden" name="conf_num" value="<?php echo $j ?>" />
			<!-- numero di campi totali da modificare -->
			</form>
<?php
						   CloseTableTitle();
					   }
?>