<?php
/**
 * @package flatnux_section_newsarhive
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']), strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN, $guestnews, $signews;
$argument = getparam("find", PAR_GET, SAN_HTML);
$op = getparam("op", PAR_GET, SAN_HTML);
$opmod = getparam("opmod", PAR_GET, SAN_HTML);

$mm = getparam("mm", PAR_GET, SAN_HTML);
$dd = getparam("dd", PAR_GET, SAN_HTML);
$yy = getparam("aa", PAR_GET, SAN_HTML);


if ( $mm != "" && intval($mm) < 10 )
{
	$mm = "0" . intval($mm);
}
if ( $dd != "" && intval($dd) < 10 )
{
	$dd = "0" . intval($dd);
}

$tablename = "news";
$tableNews = new FieldForm("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
$tableArguments = new FieldForm("fndatabase", "{$tablename}_arguments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
$DB = new XMLDatabase("fndatabase", $_FN['datadir']);

$query = "SELECT * FROM news WHERE status LIKE '1'";

if ( $argument != "" )
{
	$query .= " AND argument LIKE '$argument%'";
}
if ( $yy != "" && $mm != "" && $dd != "" )
{
	$query .= " AND date LIKE '$yy-$mm-$dd%'";
}
elseif ( $yy != "" && $mm != "" )
{
	$query .= " AND date LIKE '$yy-$mm%'";
}
elseif ( $yy != "" )
{
	$query .= " AND date LIKE '$yy-%'";
}
$query .= "ORDER BY date";
$all = $DB->query($query);
$AllnewsByArguments = array();
//dprint_r($query);
//dprint_r($all);

if ( is_array($all) )
	foreach ( $all as $item )
	{
		$AllnewsByArguments[$item['argument']][] = $item;
	}

if ( count($AllnewsByArguments) > 0 )
{
	echo "<div class=\"newsarchive_items\">";
	foreach ( $AllnewsByArguments as $argumentid => $items )
	{
		$argumentvalues = $tableArguments->xmltable->GetRecordByPrimaryKey($argumentid);
		$argumentvalues = $tableArguments->GetRecordTranslated($argumentvalues);
		$title = $argumentvalues['title'];
		$icon = "<img style=\"border:0px;\" src=\"{$_FN['datadir']}/fndatabase/{$tablename}_arguments/{$argumentvalues['unirecid']}/icon/{$argumentvalues['icon']}\" alt=\"$title\" title=\"$title\"/>";
		$href = fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;find=$argumentid");
		echo "\n<div class=\"newsarchive_item\" ><a  href=\"$href\">$icon<br />$title</a></div>";
	}
	echo "</div>";
	if ( $all )
	{
		print_years($all);
		echo "<br /><br />";
	}
	if ( $argument != "" || $yy != "" || $dd != "" || $mm != "" )
	{
		echo "<div class=\"newsarchive_list\">";
		print_list($all);
		echo "</div>";
	}
}

if ( $argument != "" || $yy != "" || $dd != "" || $mm != "" )
	echo "<div class=\"newsarchive_back\" ><a href=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}") . "\">&lt;&lt;&nbsp;" . fn_i18n("_INDIETRO") . "</a></div>";
/**
 *
 * @global array $_FN
 * @global <type> $mesi
 * @param <type> $all
 */
function print_years($all)
{
	global $_FN, $mesi;
	//$argument = intval(getparam("find", PAR_GET, SAN_HTML));
	$yy = intval(getparam("aa", PAR_GET, SAN_HTML));

	$years = array();
	foreach ( $all as $item )
	{
		$y = substr($item['date'], 0, 4);
		$years[$y][] = $item;
	}
	foreach ( $years as $year => $items )
	{
		$href = fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;aa=$year");
		echo "<br /><a href=\"$href\">$year</a> (" . count($items) . ")";
		if ( $yy != "" )
		{
			$months = array();
			foreach ( $items as $item )
			{
				$m = substr($item['date'], 5, 2);
				$months[$m][] = $item;
			}
			foreach ( $months as $month => $itemsmonth )
			{
				$href = fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;aa=$year&amp;mm=$month&amp;");
				echo "<br />&nbsp;&nbsp;&nbsp;<a href=\"$href\">" . $mesi[intval($month) - 1] . "</a> (" . count($itemsmonth) . ")";
			}
		}
	}
}
/**
 * Print arguments
 * @global array $_FN
 * @param string $argument 
 */
function print_all_by_arg($argument)
{
	global $_FN;
	$tablename = "news";
	$Table = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	$TableArgument = xmldb_form("fndatabase", $tablename . "_arguments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	$all = $Table->xmltable->getRecords(array("status" => 1, "argument" => $argument), false, false, "date", true);
	if ( $argument != "" )
	{
		$argument_values = $TableArgument->xmltable->GetRecordByPrimaryKey($argument);
		$argument_values = $TableArgument->GetRecordTranslated($argument_values);
		echo "<img alt=\"\" border=\"0\" src=\"{$_FN['datadir']}/fndatabase/{$tablename}_arguments/{$argument_values['unirecid']}/icon/{$argument_values['icon']}\" />";
		$title = $argument_values['title'];
		echo "$title<br /><br />";
		print_list($all);
	}
}
/**
 *
 * @global array $_FN
 * @param string $items
 */
function print_list($items)
{
	global $_FN;
	$tablename = "news";
	$Table = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	if ( is_array($items) )
		foreach ( $items as $item )
		{
			$item = $Table->GetRecordTranslated($item);
			$titlenews = ($item['title']);
			$txtid =
				$linkread = fn_rewritelink("index.php?mod=news&amp;op={$item['txtid']}");
			echo "<img alt=\"\" border=\"0\" src=\"" . fromtheme("images/read.png") . "\">&nbsp;<a accesskey=\"" . getaccesskey($titlenews, "$linkread ") . "\" href=\"$linkread \" alt=\"Read\">$titlenews</a><br />";
		}
}
?>