<?php
/**
 * @package flatnux_section_news
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
function news_init_tables($tablename)
{
	global $_FN;
	$id = getparam("id", PAR_GET, SAN_FLAT);

	$str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<?php exit(0);?>
<tables>
	<field>
		<name>unirecid</name>
		<primarykey>1</primarykey>
		<extra>autoincrement</extra>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>txtid</name>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>title</name>
		<frm_en>Title</frm_en>
		<frm_it>Titolo</frm_it>
		<frm_multilanguages>auto</frm_multilanguages>
	</field>
	<field>
		<name>argument</name>
		<frm_en>Argument</frm_it>
		<frm_it>Argomento</frm_it>
		<foreignkey>{$tablename}_arguments</foreignkey>
		<fk_link_field>unirecid</fk_link_field>
		<fk_show_field>title</fk_show_field>
		<frm_show_image>icon</frm_show_image>
		<frm_required>1</frm_required>
	</field>
	<field>
		<name>status</name>
		<frm_en>Status</frm_en>
		<frm_it>Stato</frm_it>
        <frm_type>radio</frm_type>
        <frm_options>1,0</frm_options>
        <frm_options_it>Pubblicata,Non pubblicata</frm_options_it>
        <frm_options_en>Active,Not active</frm_options_en>
	</field>
	<field>
		<name>summary</name>
		<frm_en>Summary</frm_en>
		<frm_it>Riassunto</frm_it>
		<frm_cols>80</frm_cols>
		<frm_rows>6</frm_rows>
		<type>text</type>
		<frm_type>html</frm_type>
		<frm_multilanguages>auto</frm_multilanguages>
		<frm_required>1</frm_required>
	</field>
	<field>
		<name>body</name>
		<frm_en>Message body</frm_en>
		<frm_it>Corpo messaggio</frm_it>
		<frm_cols>80</frm_cols>
		<frm_rows>10</frm_rows>
		<type>text</type>
		<frm_type>html</frm_type>
		<frm_multilanguages>auto</frm_multilanguages>
	</field>
	<field>
		<name>photo1</name>
		<frm_en>News image</frm_en>
		<frm_it>Immagine notizia</frm_it>
		<frm_showinlist>1</frm_showinlist>
		<thumb_listheight>64</thumb_listheight>
		<type>image</type>
		<thumbsize>250</thumbsize>
		<view_tag>center</view_tag>
	</field>
	<field>
		<name>username</name>
		<frm_en>Author</frm_en>
		<frm_it>Autore messaggio</frm_it>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>tags</name>
		<frm_en>Tags</frm_en>
		<frm_it>Tags</frm_it>
		<frm_type>string</frm_type>
	</field>
	<field>
		<name>date</name>
		<frm_en>Date</frm_en>
		<frm_it>Data</frm_it>
		<frm_type>datetime</frm_type>
		<frm_dateformat>y-mm-dd</frm_dateformat>
	</field>
	<field>
		<name>startdate</name>
		<frm_en>Publication start date</frm_en>
		<frm_it>Data inizio pubblicazione</frm_it>
		<frm_type>datetime</frm_type>
		<frm_dateformat>y-mm-dd</frm_dateformat>
	</field>
	<field>
		<name>enddate</name>
		<frm_en>Publication end date</frm_en>
		<frm_it>Data fine pubblicazione</frm_it>
		<frm_type>datetime</frm_type>
		<frm_dateformat>y-mm-dd</frm_dateformat>
	</field>
	<field>
		<name>locktop</name>
		<frm_en>Lock top</frm_en>
		<frm_it>Blocca in alto</frm_it>
		<frm_help_it>Blocca la notizia in alto alla pagina</frm_help_it>
		<frm_help_en>Lock the news in the top of page</frm_help_en>
		<frm_type>check</frm_type>
	</field>
	<field>
		<name>guestnews</name>
		<frm_en>News proposal</frm_en>
		<frm_it>Segnalata</frm_it>
		<frm_fr>Signal&eacute;es</frm_fr>

		<frm_show>0</frm_show>
	</field>
	<field>
		<name>idimport</name>
		<frm_show>0</frm_show>
	</field>
</tables>
";
	if ( !file_exists("{$_FN['datadir']}/fndatabase/$tablename.php") )
	{
		$h = fopen("{$_FN['datadir']}/fndatabase/news.php", "w");
		fwrite($h, $str);
		fclose($h);
	}
	$Table = new FieldForm("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	if ( !isset($Table->formvals['guestnews']) )
	{
		$h = fopen("{$_FN['datadir']}/fndatabase/news.php", "w");
		fwrite($h, $str);
		fclose($h);
	}
	if ( !file_exists("{$_FN['datadir']}/fndatabase/{$tablename}_arguments.php") )
	{

		$str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<?php exit(0);?>
<tables>
	<field>
		<name>unirecid</name>
		<primarykey>1</primarykey>
		<extra>autoincrement</extra>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>title</name>
		<frm_it>Titolo</frm_it>
		<frm_en>Title</frm_en>
		<frm_required>1</frm_required>
		<frm_multilanguages>auto</frm_multilanguages>
	</field>
	<field>
		<name>icon</name>
		<frm_it>Immagine argomento</frm_it>
		<frm_en>Argument image</frm_en>
		<frm_showinlist>1</frm_showinlist>
		<thumb_listheight>64</thumb_listheight>
		<type>image</type>
		<thumbsize>64</thumbsize>
		<view_tag>center</view_tag>
	</field>
	<field>
		<name>idimport</name>
		<frm_show>0</frm_show>
	</field>
</tables>
";
		$h = fopen("{$_FN['datadir']}/fndatabase/{$tablename}_arguments.php", "w");
		fwrite($h, $str);
		fclose($h);
	}


	if ( !file_exists("{$_FN['datadir']}/fndatabase/{$tablename}_comments.php") )
	{
		$str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<?php exit(0);?>
<tables>
	<field>
		<name>unirecid</name>
		<primarykey>1</primarykey>
		<extra>autoincrement</extra>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>insert</name>
		<type>string</type>
		<defaultvalue></defaultvalue>
		<frm_type>datetime</frm_type>
		<frm_dateformat>y-mm-dd</frm_dateformat>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>username</name>
		<type>string</type>
		<frm_show>0</frm_show>
		<frm_required>1</frm_required>
	</field>
	<field>
		<name>comment</name>
		<frm_it>Commento</frm_it>
		<frm_en>Comment</frm_en>
		<type>text</type>
		<frm_type>bbcode</frm_type>
		<frm_rows>auto</frm_rows>
		<frm_required>1</frm_required>
		<frm_cols>80</frm_cols>
	</field>
	<field>
		<name>idimport</name>
		<frm_show>0</frm_show>
	</field>
	<field>
		<name>unirecidrecord</name>
		<frm_show>0</frm_show>
	</field>
	<indexfield>unirecidrecord</indexfield>
</tables>
";
		$h = fopen("{$_FN['datadir']}/fndatabase/{$tablename}_comments.php", "w");
		fwrite($h, $str);
		fclose($h);
	}
	$tablearguments = xmldb_form("fndatabase", $tablename . "_arguments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	// la prima volta metto almenu un argomento--->
	//$tablearguments = xmldb_table("fndatabase", "{$tablename}_arguments");
	$args = $tablearguments->xmltable->GetRecords();
	if ( !is_array($args) || count($args) == 0 )
	{
		$newvalues = array();
		$newvalues['title'] = "News";
		$newvalues['icon'] = "news.png";
		$_FILES['icon']['name'] = "news.png";
		$_FILES['icon']['tmp_name'] = "images/news/news.png";
		$newvalues = $tablearguments->xmltable->InsertRecord($newvalues);
	}
	// la prima volta metto almenu un argomento---<
}
/**
 * get array with news values
 * 
 * @param array $itemnews 
 * 
 */
function get_news_contents($newsvalues)
{
	global $_FN;
	static $id_accesskey = 1;
	$Table = xmldb_form("fndatabase", $_FN['news_tablename'], $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	$item = $Table->GetRecordTranslated($newsvalues);
	if ( !isset($item['txtid']) )
	{
		//dprint_r($newsvalues);
		//return false;
	}
	$item['op'] = getparam("op", PAR_GET, SAN_FLAT);

	//read news---->
	$_LEGGITUTTO = fn_i18n("_LEGGITUTTO");
	$item['accesskey_READ'] = getaccesskey($_LEGGITUTTO, $_FN['idmod'] . "&amp;op={$item['txtid']}", "$id_accesskey");
	$id_accesskey++;
	$item['news_USER'] = $item['username'];
	if ( $item['news_USER'] == "" )
	{
		$item['news_USER'] = fn_i18n("_SCON");
	}
	$item['txt_READ'] = $_LEGGITUTTO;
	$item['link_READ'] = fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op={$item['txtid']}");
	//read news----<
	//print news---->
	$_STAMPA = fn_i18n("_STAMPA");
	$accstampa = getaccesskey($_STAMPA, "print.php?mod={$_FN['idmod']}&amp;op={$item['txtid']}");
	$item['accesskey_PRINT'] = $accstampa;
	$item['txt_PRINT'] = $_STAMPA;
	$item['link_PRINT'] = "print.php?mod={$_FN['idmod']}&amp;op={$item['txtid']}";
	//print news----<
	//modify news---->
	$item['link_MODIFY'] = "";
	$item['txt_MODIFY'] = fn_i18n("_MODIFICA");
	if ( is_news_administrator ( ) )
	{
		$item['link_MODIFY'] = fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=edit&amp;pk___xdb_news={$item['unirecid']}&amp;op___xdb_news=insnew");
	}
	//modify news----<
	//fb---->
	include ("sections/{$_FN['vmod']}/config.php");
	$item['facebook_button_i_like'] = "";
	if ( $enable_facebook )
	{
		$strfacebook = "<br /><br />
			<iframe
				src=\"http://www.facebook.com/plugins/like.php?href=";
		$strfacebook.= urlencode($_FN['siteurl'] . fn_rewritelink("index.php?mod=" . $_FN['idmod'] . "&amp;op={$item['txtid']}")) . "";
		$strfacebook.= "&amp;layout=standard&amp;show_faces=false&amp;width=450&amp;action=like&amp;colorscheme=light\"
			scrolling=\"no\" frameborder=\"0\" allowtransparency=\"true\"
			style=\"border: none; overflow: hidden; width: 450px; height: 60px\"></iframe>";
		$item['facebook_button_i_like'] = $strfacebook;
	}
	//fb----<
	$item['txt_POSTED'] = fn_i18n("_POSTATO");
	//dprint_r($item);
	$item['txt_DATE'] = html_date($item['date']);
	$item['news_SUMMARY'] = tag2html(str_replace("\r", "", str_replace("\n", "", ($item['summary']))));
	$item['news_BODY'] = tag2html(str_replace("\r", "", str_replace("\n", "", ($item['body']))));
	$item['news_TITLE'] = htmlentities($item['title'], ENT_QUOTES);
	$view = get_news_stat($tablename, $item, "unirecid");
	$item['news_VIEWS'] = $view;
	$item['txt_VIEWS'] = fn_i18n("_LETTO") . " " . $view . " " . fn_i18n("_VOLTE");
	$item['img_argument'] = "";
	$item['argument_values'] = array();
	$item['img_argument_thumb'] = "";
	if ( $item['argument'] != "" )
	{
		$TableArguments = xmldb_form("fndatabase", $tablename . "_arguments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
		$argvalues = $TableArguments->xmltable->GetRecordByPrimaryKey($item['argument']);
		if ( isset($argvalues['icon']) )
		{
			$item['argument_values'] = $argvalues;
			$TableArguments->GetRecordTranslated($argvalues);
			$item['img_argument'] = "{$_FN['datadir']}/fndatabase/{$tablename}_arguments/{$argvalues['unirecid']}/icon/" . $argvalues['icon'];
			$item['img_argument_thumb'] = "{$_FN['datadir']}/fndatabase/{$tablename}_arguments/{$argvalues['unirecid']}/icon/thumbs/" . $argvalues['icon'] . ".jpg";
			$item['title_argument'] = htmlentities($argvalues['title'], ENT_QUOTES);
		}
	}
	$item['img_news'] = "";
	$item['img_news_thumb'] = "";
	if ( $item['photo1'] != "" )
	{
		$item['img_news'] = "{$_FN['datadir']}/fndatabase/$tablename/{$item['unirecid']}/photo1/" . $item['photo1'];
		$item['img_news_thumb'] = "{$_FN['datadir']}/fndatabase/$tablename/{$item['unirecid']}/photo1/thumbs/" . $item['photo1'] . ".jpg";
	}

	if ( $_FN['news_enablecomments'] )
	{
		$comments = nw_get_comments($item['unirecid']);
		$item['COMMENTS'] = $comments;
		$item['txt_NUMCOMMENTS'] = count($comments) . " " . fn_i18n("_COMMENTI");
		//-----------------------
		$item['link_COMMENTS'] = fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=comment&amp;id={$item['unirecid']}");
		$item['txt_COMMENTS'] = fn_i18n("_COMMENTI");
		$item['accesskey_COMMENTS'] = getaccesskey($item['txt_COMMENTS'], $_FN['idmod'] . "&amp;op=comment&amp;id={$item['unirecid']}");
		//-----------------------
		$item['txt_WRITECOMMENT'] = fn_i18n('_ADDCOMM');
		$item['accesskey_WRITECOMMENT'] = getaccesskey($item['txt_WRITECOMMENT'], $_FN['idmod'] . "&amp;op=comment&amp;id={$item['unirecid']}");
		$item['link_WRITECOMMENT'] = fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=comment&amp;id={$item['unirecid']}");
	}
	return $item;
}
/**
 * print date of news
 *
 * @param string $date
 * @return string
 */
function html_date($date)
{
	if ( $date == "" )
		return "";
	global $mesi;
	$date = explode("-", $date);
	if ( !isset($date[1]) )
		return "";
	//dprint_r($date);
	$h = explode(" ", $date[2]);
	$h = isset($h[1]) ? $h[1] : "";
	return intval($date[2]) . " " . $mesi[intval($date[1]) - 1] . " " . $date[0] . " - " . $h;
}
/**
 * return true if the user is administrator
 *
 * @return bool
 */
function is_news_administrator()
{
	global $_FN;
	$group_news = "news";
	include ("sections/{$_FN['vmod']}/config.php");
	CreateGroupIfNotExists($group_news);

	if ( $_FN['user'] != "" && $group_news != "" && user_in_group($_FN['user'], $group_news) )
		return true;
	return is_admin();
}
/**
 * news_writecomment_form
 * aggiunge un commento al record
 *
 * @param array record
 */
function news_writecomment_form($newsvalues)
{
	global $_FN;
	$unirecid = $newsvalues['unirecid'];
	if ( $_FN['user'] == "" && !$_FN['news_guestcomment'] )
	{
		echo fn_i18n("_DEVIREG") . " " . $_FN['sitename'] . " " . fn_i18n("_DEVIREG2");
		fn_loginform();
	}
	else
	{
		$tablelinks = new FieldForm("fndatabase", $_FN["news_tablename"] . "_comments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
		$tablelinks->setlayout("table");
		$text = getparam("comment", PAR_POST, SAN_FLAT);
		if ( isset($_POST['comment']) )
		{
			$newvalues = $tablelinks->getbypost();
			$newvalues['comment'] = htmlspecialchars($newvalues['comment']);
			$newvalues['comment'] = news_fixnewline($newvalues['comment']);
			$newvalues['unirecidrecord'] = $unirecid;
			$newvalues['username'] = $_FN['user'];
			$newvalues['insert'] = fn_time();
			if ( $text == "" )
			{
				echo fn_i18n("_FERRCAMPO") . ":<br />";
				$tit = fn_i18n("_INDIETRO");
				echo "<a accesskey=" . getaccesskey($tit, "javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a><br /><br />";
			}
			else
			{
				if ( is_spam($text) )
				{
					echo fn_i18n("_THISISSPAM");
					$tit = fn_i18n("_INDIETRO");
					echo "<br /><br /><a accesskey=" . getaccesskey($tit, "javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a><br /><br />";
					return;
				}

				$tablelinks->xmltable->InsertRecord($newvalues);
				echo fn_i18n("_FMESSOK") . "<br />";
				jsredirect(fn_rewritelink("index.php?mod={$_FN['idmod']}&op=read&id=$unirecid", "&"));
				FN_log("Comment added: table {$_FN["news_tablename"]}, record $unirecid");
			}
		}
		else
		{
			if ( $unirecid != "" )
			{
				echo "\n<form method=\"post\" enctype=\"multipart/form-data\" action=\"index.php?mod={$_FN['mod']}&id=$unirecid&op=comment\" >";
				//echo "<b>".fn_i18n("_FP_ADDCOMM")."</b><br />";
				$tablelinks->formvals['comment']['title'] = fn_i18n("_FP_ADDCOMM");
				$tablelinks->requiredtext = "";
				$tablelinks->setlayoutTags("<b>", ":</b><div>", "</div>", "<br /><br />");
				$tablelinks->ShowInsertForm();
				echo "<input class=\"submit\" type=\"submit\" value=\"" . fn_i18n("_SAVE") . "\"/>";
				echo "<input type='button' class='button' onclick='window.location=(\"index.php?mod={$_FN['mod']}\")'  value='" . fn_i18n("_CANCEL") . "' />";
				echo "\n</form>";
			}
		}
	}
}
/**
 *
 * @param string $unirecid
 * @param string $tablename
 */
function nw_get_comments($idnews)
{
	global $_FN;
	$tablelinks = new FieldForm("fndatabase", $_FN["news_tablename"] . "_comments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	$r['unirecidrecord'] = $idnews;
	$comments = $tablelinks->xmltable->GetRecords($r, false, false, "unirecid", false);
	foreach ( $comments as $k => $comment )
	{
		$comments[$k]['txt_FROM'] = fn_i18n("_DA");
		$comments[$k]['html_USER'] = $comment['username'];
		if ( $comments[$k]['html_USER'] == "" )
			$comments[$k]['html_USER'] = fn_i18n("_SCON");

		$comments[$k]['img_USER'] = fromtheme("images/avatars/blank.png");
		if ( $comment['username'] != "" && $uservalues = get_user($comment['username']) )
		{
			//immagine utente ---->
			if ( isset($uservalues['avatar']) && $uservalues['avatar'] != "" )
			{
				$comments[$k]['img_USER'] = $_FN['datadir'] . "/fndatabase/users/{$comment['username']}/avatar/" . $uservalues['avatar'];
			}
			else
			{
				if ( isset($uservalues['avatarimage']) && $uservalues['avatarimage'] != "" )
				{
					$comments[$k]['img_USER'] = ($_FN['datadir'] . "/fndatabase/avatars/" . urlencode($uservalues['avatarimage']) . "/filename/" . $uservalues['avatarimage']);
				}
			}
			//immagine utente ----<
		}
		$comments[$k]['txt_DATE'] = fn_i18n("_DATA");
		$comments[$k]['html_DATE'] = fn_GetDateTime($comment['insert']);
		$comments[$k]['html_COMMENT'] = tag2html($comment['comment']);
		$unirecidrecord = $comment['unirecid'];
		$comments[$k]['html_DELCOMMENT'] = "<a href=\"javascript:check('?mod={$_FN['mod']}&op=del_news_comment&id=$idnews&unirecidrecord=$unirecidrecord')\" >" . fn_i18n("_ELIMINA") . "</a>";
	}
	return $comments;
}
/**
 * del_news_comment
 *
 * elimina un commento dal record
 * @param string unirecid record
 */
function del_news_comment($unirecid, $tablename)
{
	global $_FN;
	$databasename = "fndatabase";
	$tablelinks = new FieldForm("$databasename", "$tablename" . "_comments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	$unirecidrecord = getparam('unirecidrecord', PAR_GET, SAN_HTML);
	if ( is_admin() && isset($_GET['unirecidrecord']) && $unirecidrecord != "" )
	{
		$unirecidrecord = intval($unirecidrecord);
		$tablelinks->xmltable->DelRecord($unirecidrecord);
		echo fn_i18n("The_comment_was_deleted") . "<br />";
		FN_log("Comment deleted:table $tablename, record $unirecid");
		$Table = new FieldForm($databasename, $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
		$newvalues = $Table->xmltable->GetRecordByPrimaryKey($unirecid);
	}
}
/**
 * 
 * @global array $_FN
 * @param string $groupname
 */
function CreateGroupIfNotExists($groupname)
{
	global $_FN;
	$table = new XMLTable("fndatabase", "groups", $_FN['datadir']);
	$old = $table->GetRecordByPrimaryKey($groupname);
	if ( !isset($old['groupname']) )
	{
		$table->InsertRecord(array("groupname" => $groupname));
	}
}
//---------textarea--------------------------------------->
class xmldbform_field_bbcode
{
	function xmldbform_field_bbcode()
	{

	}
	function show($params)
	{
		$this->starttagtitle = isset($params['frm_starttagtitle']) ? $params['frm_starttagtitle'] : "<tr><td  valign=\"top\" >";
		$this->endtagtitle = isset($params['frm_endtagtitle']) ? $params['frm_endtagtitle'] : "</td>";
		$this->starttagvalue = isset($params['frm_starttagvalue']) ? $params['frm_starttagvalue'] : "<td valign=\"top\" >";
		$this->endtagvalue = isset($params['frm_endtagvalue']) ? $params['frm_endtagvalue'] : "</td></tr>";
		$rows = isset($params['frm_rows']) ? $params['frm_rows'] : 4;
		$cols = isset($params['frm_cols']) ? $params['frm_cols'] : 20;
		$strhiddenfield = $params['strhiddenfield'];
		$languagesfield = $params['languagesfield'];
		$lang_noprefix = $params['lang_noprefix'];
		$oldvalues = $params['oldvalues'];
		$tooltip = $params['frm_help'];
		echo $this->starttagtitle . $params['title'] . $this->endtagtitle;
		echo $this->starttagvalue;
		echo $strhiddenfield;
		if ( $params['multilanguage'] )
		{
			echo "<table height=\"0\" style=\"border:0px;padding:0px\" callpadding=\"0\" cellspacing=\"0\"  border=\"0\"><tr><td>";
			draw_languages($params, $params['lang']);
			echo "\n<div style=\"display:block;overflow:hidden\" id=\"__frmdb_" . $params['name'] . "\" >";
		}
		bbcodes_js();
		bbcodes_panel($params['name'], "formatting");
		bbcodes_panel($params['name'], "emoticons");
		echo "<br />";
		xmldbform_print_field_text($params['name'], $params['value'], $rows, $cols, $tooltip);
		if ( $params['multilanguage'] )
		{
			echo "<br />\n" . xmldb_get_lang_img_local($params['lang_user']) . "";
			echo "</div>";
		}
		if ( $params['multilanguage'] )
		{
			foreach ( $languagesfield as $tl )
			{
				$suffix = ($tl != $lang_noprefix) ? "_$tl" : "";
				if ( $tl != $params['lang_user'] )
				{
					if ( !isset($oldvalues[$params['realname'] . $suffix]) )
						$oldvalues[$params['realname'] . $suffix] = "";
					echo "\n<div style=\"display:block;overflow:hidden;height:1px;width:1px;\" id=\"__frmdb_" . $params['realname'] . "$suffix" . "\" >";
					xmldbform_print_field_text($params['realname'] . $suffix, $oldvalues[$params['realname'] . $suffix], $rows, $cols, $params['frm_help']);
					echo "<br />\n" . xmldb_get_lang_img_local($tl) . "</div>\n";
				}
			}
		}
		if ( $params['multilanguage'] )
			echo "</td></tr></table>";
		echo $this->endtagvalue;
	}
}
//---------textarea---------------------------------------<



function submit_news($tablename)
{
	global $_FN;
	$table = new FieldForm("fndatabase", "$tablename", $_FN['datadir'], $_FN['lang'], $_FN['languages']);

	$table->formvals['summary']['frm_type'] = "bbcode";
	$table->formvals['summary']['frm_multilanguages'] = "";
	$table->formvals['body']['frm_type'] = "bbcode";
	$table->formvals['body']['frm_multilanguages'] = "";
	$table->formvals['title']['frm_multilanguages'] = "";
	$table->formvals['title']['frm_required'] = "1";

	$table->formvals['locktop']['frm_show'] = "0";
	$table->formvals['tags']['frm_show'] = "0";
	$table->formvals['status']['frm_show'] = "0";
	$table->formvals['locktop']['frm_show'] = "0";
	$table->formvals['date']['frm_show'] = "0";
	$table->formvals['startdate']['frm_show'] = "0";
	$table->formvals['enddate']['frm_show'] = "0";
	$table->formvals['photo1']['frm_show'] = "0";



	$save = getparam("save", PAR_GET, SAN_FLAT);
	$table->LoadFieldsClasses();
	$table->setlayoutTags("<b>", ":</b><div>", "</div>", "<br /><br />");

	$newvalues = array();
	//<script>alert('a')</script>ciao
	$newvalues = $table->getbypost();
	$newvalues['title'] = strippostpslashes(getparam("title", PAR_POST, SAN_FLAT));
	$newvalues['body'] = isset($newvalues['body']) ? $newvalues['body'] : "";
	$newvalues['summary'] = isset($newvalues['summary']) ? $newvalues['summary'] : "";


	//dprint_r($newvalues);

	$newvalues['status'] = 0;
	$newvalues['locktop'] = 0;
	$newvalues['date'] = fn_now();
	$newvalues['startdate'] = "";
	$newvalues['enddate'] = "";
	$newvalues['tags'] = "";
	$newvalues['username'] = $_FN['user'];
	$newvalues['guestnews'] = "1";


	if ( $newvalues['title'] != "" )
	{
		$textid = gen_txt_id($newvalues['title'], $tablename);
		$newvalues['txtid'] = $textid;
	}
	//dprint_r($newvalues);
	if ( $save )
	{
		if ( is_spam($newvalues['body'] . $newvalues['summary']) )
		{
			echo fn_i18n('_THISISSPAM');
			return;
		}
		$errors = $table->VerifyExt($newvalues);
		if ( is_array($errors) && count($errors) > 0 )
		{
			foreach ( $errors as $field => $error )
			{
				$table->setlayoutTag($field, "<b>", ":</b>&nbsp;<span style=\"background-color:#ffffff;color:red\">{$error['error']}</span>", "<br />", "<br /><br />", "<fieldset><legend>", "</legend>", "", "</fieldset>");
			}
		}
		else
		{
			$newvalues['title'] = htmlspecialchars($newvalues['title']);
			$newvalues['body'] = htmlspecialchars($newvalues['body']);
			$newvalues['summary'] = htmlspecialchars($newvalues['summary']);
			// trasforma "\n\r" , "\r" in "\n" e quindi in "<br />"
			$newvalues['body'] = news_fixnewline($newvalues['body'], true);
			$newvalues['summary'] = news_fixnewline($newvalues['summary'], true);
			$table->xmltable->InsertRecord($newvalues);
			fn_log("Submit news " . $newvalues['title']);
			echo "<div>";
			echo fn_i18n("_ALERTSIG");
			echo "<br />";
			echo "<br />";
			echo "<a href=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}") . "\">" . fn_i18n("_AVANTI") . " &gt;&gt;</a>";
			echo "</div>";
			return;
		}
	}

	//$table->LoadFieldsForm();

	echo "<form method=\"post\" action=\"" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=submitnews&amp;save=1") . "\">";
	$table->ShowInsertForm(is_admin(), $newvalues);
	echo "<button type=\"submit\">" . fn_i18n("_SAVE") . "</button>";
	echo "</form>";
}
//------themable

function news_fixnewline($text, $tobr=false)
{
	$eol = "\n";
	$text = str_replace("\r\n", "\n", $text);
	$text = str_replace("\r", "", $text);
	$text = str_replace("\n", "$eol", $text);
	if ( $tobr )
		$text = str_replace("\n", "<br />", $text);
	return $text;
}
/**
 * print news list
 *
 * @param string $tablename
 */
function print_list_news()
{
	global $_FN;
	$newspp = 10;
	$tablename = "";
	include ("sections/{$_FN['vmod']}/config.php");
	$DB = new XMLDatabase("fndatabase", $_FN['datadir']);

	$all = $DB->query("SELECT * FROM $tablename WHERE status LIKE '1' ORDER BY date DESC");
	//$Table = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	//$all = $Table->xmltable->getRecords(array("status" => 1), false, false, "date", true);
	//dprint_r($all);
	$idlang = "";
	if ( $_FN['lang'] != $_FN['lang_default'] )
	{
		$idlang = "_{$_FN['lang']}";
	}
	$locktop = array();
	$newstoprint = array();

	$curtime = fn_time();
	if ( is_array($all) )
	{
		$i = 1;
		foreach ( $all as $item )
		{
			if ( $item['title' . $idlang] != "" || $item['body' . $idlang] != "" || $item['summary' . $idlang] != "" )
			{

				$enddate = strtotime($item['startdate']);

				if ( $item['startdate'] != "" && $curtime < strtotime($item['startdate']) )
				{
					//echo "<br />min".$curtime."<".strtotime($item['startdate']);
					continue;
				}
				if ( $item['enddate'] != "" && $curtime > strtotime($item['enddate']) )
				{
					//echo "<br />magg".strtotime($item['startdate'])."=".date("Y-m-d H:i:s", strtotime($item['startdate']))."=".$item['startdate'];
					continue;
				}

				if ( $i > $newspp )
					break;
				if ( $item['locktop'] )
				{
					$locktop[] = get_news_contents($item, $tablename);
				}
				else
					$newstoprint[] = get_news_contents($item, $tablename);

				$i++;
			}
		}
	}
	if ( count($locktop) > 0 )
		echo "<div class=\"news_locktop\">";
	foreach ( $locktop as $news_values )
	{
		news__print_news_summary($news_values);
	}

	if ( count($locktop) > 0 )
		echo "</div>";
	echo "<div class=\"news_list_news\">";
	foreach ( $newstoprint as $news_values )
	{
		news__print_news_summary($news_values);
	}
	echo "</div>";
}
/**
 *
 * @global array $_FN
 * @param <type> $text
 * @param <type> $tablename
 * @return string
 */
function gen_txt_id($text, $tablename="")
{
	global $_FN;
	if ( $tablename == "" )
	{
		include ("sections/{$_FN['vmod']}/config.php");
	}
	$table = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	$text = strtolower(str_replace(" ", "_", $text));
	$text = preg_replace("//s", "a", $text);
	$text = preg_replace("//s", "a", $text);
	$text = preg_replace("//s", "e", $text);
	$text = preg_replace("//s", "e", $text);
	$text = preg_replace("//s", "i", $text);
	$text = preg_replace("//s", "i", $text);
	$text = preg_replace("//s", "o", $text);
	$text = preg_replace("//s", "o", $text);
	$text = preg_replace("//s", "u", $text);
	$text = preg_replace("//s", "u", $text);
	$text = preg_replace("/[^A-Z^a-z_0-9]/s", "_", $text);
	$text = str_replace("-", "_", $text);
	$text = str_replace(".", "_", $text);
	$acc = "";
	do
	{
		$textid = $text . $acc;
		$rec = $table->xmltable->GetRecord(array("txtid" => $textid));
		$acc = intval($acc) + 1;
	} while ( isset($rec['unirecid']) );
	return $textid;
}
/**
 * generete rss
 *
 */
function generate_RSS()
{

	global $_FN;
	$newspp = 10;
	$tablename = "";
	include ("sections/{$_FN['vmod']}/config.php");
	$DB = new XMLDatabase("fndatabase", $_FN['datadir']);

	$all = $DB->query("SELECT * FROM $tablename WHERE status LIKE '1' ORDER BY date DESC");
	//$Table = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	//$all = $Table->xmltable->getRecords(array("status" => 1), false, false, "date", true);
	//dprint_r($all);
	foreach ( $_FN['listlanguages'] as $llang )
	{
//	$llang = $_FN['lang'];
		$idlang = "";
		if ( $llang != $_FN['lang_default'] )
		{
			$idlang = "_{$llang}";
		}
		$locktop = array();
		$newstoprint = array();
		$curtime = fn_time();
		if ( is_array($all) )
		{
			$i = 1;
			foreach ( $all as $item )
			{
				if ( $item['title' . $idlang] != "" || $item['body' . $idlang] != "" || $item['summary' . $idlang] != "" )
				{

					$enddate = strtotime($item['startdate']);

					if ( $item['startdate'] != "" && $curtime < strtotime($item['startdate']) )
					{
						continue;
					}
					if ( $item['enddate'] != "" && $curtime > strtotime($item['enddate']) )
					{
						continue;
					}
					if ( $i > $newspp )
						break;
					if ( $item['locktop'] )
					{
						$locktop[] = get_news_contents($item, $tablename);
					}
					else
					{
						$newstoprint[] = get_news_contents($item, $tablename);
					}
					$i++;
				}
			}
		}
		$body = "<?xml version='1.0' encoding='ISO-8859-1'?>\n<rss version='2.0'>\n\t<channel>\n";
		// informazioni generali sul feed
		$body.="\t\t<title>{$_FN['sitename']}</title>\n\t\t<link>{$_FN['siteurl']}</link>\n\t\t<description><![CDATA['{$_FN['sitename']}' HEADLINES]]></description>\n";
		$body.="\t\t<managingEditor>{$_FN['admin_mail']}</managingEditor>\n\t\t<generator>FlatNux RSS Generator - http://www.flatnux.sf.org</generator>\n";
		$body.="\t\t<lastBuildDate>" . date("Y-m-d H:i:s") . " GMT</lastBuildDate>\n";

		foreach ( $locktop as $news_values )
		{
			$body.="\t\t<item>\n";
			$body.="\t\t\t<title>{$news_values['news_TITLE']}</title>\n";
			$body.="\t\t\t<link>{$_FN['siteurl']}{$news_values['link_READ']}</link>\n\t\t\t<description><![CDATA[{$news_values['news_SUMMARY']}]]></description>\n";
			$body.="\t\t\t<pubDate>" . date("Y-m-d H:i:s", strtotime($news_values['date'])) . " GMT</pubDate>\n";
			$body.="\t\t</item>\n";
		}
		foreach ( $newstoprint as $news_values )
		{
			$body.="\t\t<item>\n";
			$body.="\t\t\t<title>{$news_values['news_TITLE']}</title>\n";
			$body.="\t\t\t<link>{$_FN['siteurl']}{$news_values['link_READ']}</link>\n\t\t\t<description><![CDATA[{$news_values['news_SUMMARY']}]]></description>\n";
			$body.="\t\t\t<pubDate>" . date("Y-m-d H:i:s", strtotime($news_values['date'])) . " GMT</pubDate>\n";
			$body.="\t\t</item>\n";
		}
		$body.="\t</channel>\n</rss>";
		// scrittura del feed
		$fp = fopen($_FN['datadir'] . "/$llang/backend.xml", "w");
		fwrite($fp, "$body");
		fclose($fp);
		//dprint_xml($body);
	}
}
/**
 * generete rss
 *
 */
function generate_GOOGLESITEMAP()
{

	global $_FN;
	$DB = new XMLDatabase("fndatabase", $_FN['datadir']);
	$all = $DB->query("SELECT * FROM {$_FN['news_tablename']} WHERE status LIKE '1'");
	$newstoprint = array();
	foreach ( $_FN['listlanguages'] as $llang )
	{
		$idlang = "";
		if ( $llang != $_FN['lang_default'] )
		{
			$idlang = "_{$llang}";
		}
		$locktop = array();
		$curtime = fn_time();
		if ( is_array($all) )
		{
			foreach ( $all as $item )
			{
				if ( $item['title' . $idlang] != "" || $item['body' . $idlang] != "" || $item['summary' . $idlang] != "" )
				{
					$enddate = strtotime($item['startdate']);
					if ( $item['startdate'] != "" && $curtime < strtotime($item['startdate']) )
					{
						continue;
					}
					if ( $item['enddate'] != "" && $curtime > strtotime($item['enddate']) )
					{
						continue;
					}
					$newstoprint[] = $item;
				}
			}
		}
	}

	$body = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">";
	foreach ( $newstoprint as $news_values )
	{
		$link = fn_rewritelink("index.php?mod=news&amp;op={$item['txtid']}");
		$body.= "\n\t<url><loc>{$_FN['siteurl']}{$link}</loc></url>";
	}
	$body .= "\n</urlset><!-- end -->";
	// scrittura del feed
	$fp = fopen("sitemap_news.xml", "w");
	fwrite($fp, "$body");
	fclose($fp);
	//dprint_xml($body);
}
/**
 * count news has for the current language
 *
 * @author Simone Vellei <simone_vellei@users.sourceforge.net>
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 *
 */
function count_sig_news($tablename="news")
{
	global $_FN;
	$DB = new XMLDatabase("fndatabase", $_FN['datadir']);
	$news = $DB->query("SELECT unirecid FROM $tablename WHERE status LIKE '0'");
	if ( !is_array($news) )
		return 0;
	return (count($news));
}
/**
 *
 * @param string $tablename
 * @param array $row
 * @param string $pkf
 */
function update_news_stat($tablename, $row, $pkf="unirecid")
{
	global $_FN;
	//-------statistiche---------------------->>
	if ( !file_exists("{$_FN['datadir']}/fndatabase/$tablename" . "_stat") )
	{
		$sfields = array();
		$sfields[0]['name'] = "unirecid";
		$sfields[0]['primarykey'] = "1";
		$sfields[1]['name'] = "view";
		echo createxmltable("fndatabase", $tablename . "_stat", $sfields, $_FN['datadir']);
	}
	$tbtmp = xmldb_table("fndatabase", $tablename . "_stat", $_FN['datadir']);
	$tmprow['unirecid'] = $row[$pkf];
	if ( ($oldview = $tbtmp->GetRecordByPrimaryKey($row[$pkf])) == false )
	{
		$tmprow['view'] = 1;
		$rowtmp = $tbtmp->InsertRecord($tmprow);
	}
	else
	{
		$oldview['view']++;
		$rowtmp = $tbtmp->UpdateRecord($oldview); //aggiunge vista
	}
	//-------statistiche----------------------<<
}
/**
 *
 * @global array $_FN
 * @param <type> $tablename
 * @param <type> $row
 * @param <type> $pkf
 * @return <type>
 */
function get_news_stat($tablename, $row, $pkf="unirecid")
{
	global $_FN;
	if ( !file_exists("{$_FN['datadir']}/fndatabase/$tablename" . "_stat") )
	{
		return 0;
	}
	$tbtmp = xmldb_table("fndatabase", $tablename . "_stat", $_FN['datadir']);
	$tmprow['unirecid'] = $row[$pkf];
	if ( ($oldview = $tbtmp->GetRecordByPrimaryKey($row[$pkf])) == false )
	{
		return 0;
	}
	else
	{
		return intval($oldview['view']);
	}
}
if ( !function_exists("news__print_news") )
{
	/**
	 *
	 * @global array $_FN
	 * @param <type> $news_values
	 * @param <type> $tablename
	 */
	/*
	 * $news_values:
	 *
	  [unirecid] => 1
	  [txtid] => ciao_
	  [title] => CIAO
	  [argument] => 2
	  [status] => 1
	  [summary] =>
	  [body] =>
	  [photo1] =>
	  [username] =>
	  [tags] =>
	  [date] => 2011-01-02 23:51:23
	  [startdate] =>
	  [enddate] =>
	  [locktop] =>
	  [idimport] =>
	  [title_en] =>
	  [title_es] =>
	  [title_de] =>
	  [title_fr] =>
	  [summary_en] =>
	  [summary_es] =>
	  [summary_de] =>
	  [summary_fr] =>
	  [body_en] =>
	  [body_es] =>
	  [body_de] =>
	  [body_fr] =>
	  [accesskey_READ] => 1
	  [txt_READ] => Leggi tutto
	  [link_READ] => index.php?mod=news&op=ciao_
	  [accesskey_PRINT] => m
	  [txt_PRINT] => Stampa
	  [link_PRINT] => print.php?mod=news&op=ciao_
	  [link_MODIFY] => index.php?mod=news&op=edit&opmod=insnew_news&pk___xdb_news=1&op___xdb_news=insnew
	  [txt_MODIFY] => Modifica
	  [facebook_button_i_like] =>
	  [txt_POSTED] => Postato
	  [txt_DATE] => 2 Gennaio 2011 - 23:51:23
	  [news_SUMMARY] =>
	  [news_BODY] =>
	  [news_TITLE] => CIAO
	  [news_VIEWS] => 40
	  [txt_VIEWS] => letto  40 volte
	  [img_argument] => misc/fndatabase/news_arguments/2/icon/Pampel2011.png
	  [argument_values] => Array
	  (
	  [unirecid] => 2
	  [title] => pampel
	  [icon] => Pampel2011.png
	  [idimport] =>
	  [title_en] =>
	  [title_es] =>
	  [title_de] =>
	  [title_fr] =>
	  )
	  [img_argument_thumb] => misc/fndatabase/news_arguments/2/icon/thumbs/Pampel2011.png.jpg
	  [title_argument] => pampel
	  [img_news] =>
	  [img_news_thumb] =>
	 */
	function news__print_news($news_values)
	{
		global $_FN;
		OpenTableTitle("{$news_values['news_TITLE']}");
		// print summary
		echo $news_values['news_SUMMARY'];
		echo "<br />\n";
		// print body
		echo $news_values['news_BODY'];
		// print footer
		echo "<hr />\n<div class=\"news_footer\">";
		echo $news_values['txt_POSTED'] . $news_values['txt_DATE'];
		echo fn_i18n("_DA") . $news_values['news_USER'];
		echo "</div>";
		if ( is_news_administrator ( ) )
		{
			echo "<br /><a href=\"{$news_values['link_MODIFY']}\">[{$news_values['txt_MODIFY']}]</a>";
		}
		if ( $_FN['news_enablecomments'] )
		{
			news__print_comments($news_values);
			echo "<div class=\"news_comment_login\" >";
			news_writecomment_form($news_values);
			echo "</div>";
		}
		CloseTableTitle();
	}
}
/**
 *
 * @param array $newsvalues
 */
if ( !function_exists("news__print_news_summary") )
{
	//------------------ITEM------------------------------------------------------<
	/**
	 *
	 * @param $item
	 */
	function news__print_news_summary($item)
	{
		global $_FN;
		static $i = 0;
		$i++;
		FN_OpenNews("{$item['title']}");
		echo "{$item['news_SUMMARY']}";
		if ( $item['img_argument'] != "" )
		{
			echo "<div class=\"img_argument\"><img  alt=\"\"  title = \"{$item['title_argument']}\"  src=\"{$item['img_argument']}\"></div>";
		}

		if ( $item['img_news'] != "" )
		{
			echo "<div class=\"img_news\"><img alt=\"\" style=\"border:0px;\" src=\"{$item['img_news']}\" /></div>";
		}

		//footer ------>
		echo "<br /><div style=\"text-align:center\">", $item['txt_POSTED'] . $item['txt_DATE'] . " (" . $item['txt_VIEWS'] . ")";
		echo "<br />";
		echo "<img src=\"" . fromtheme("images/read.png") . "\" alt=\"Read\" />&nbsp;<a accesskey=\"{$item['accesskey_READ']}\" href=\"" . $item['link_READ'] . "\" title=\"" . $item['txt_READ'] . " " . $item['news_TITLE'] . "\" ><b>" . $item['txt_READ'] . "</b></a>";
		echo " | <img  src=\"" . fromtheme("images/print.png") . "\" alt=\"" . $item['txt_PRINT'] . "\" />&nbsp;<a accesskey=\"{$item['accesskey_PRINT']}\" href=\"{$item['link_PRINT']}" . "\" title=\"" . $item['txt_PRINT'] . " " . $item['news_TITLE'] . "\" >" . $item['txt_PRINT'] . "</a>";
		if ( $_FN['news_enablecomments'] )
		{
			echo " | <img  src=\"" . fromtheme("images/comment.png") . "\" alt=\"\"  />&nbsp;<a href=\"{$item['link_COMMENTS']}\" >" . $item['txt_NUMCOMMENTS'] . "</a>";
		}
		if ( $item['link_MODIFY'] != "" )
		{
			echo " | <img  src=\"" . fromtheme("images/modify.png") . "\" alt=\"" . $item['txt_MODIFY'] . "\" title=\"" . $item['txt_MODIFY'] . "\" />&nbsp;<a href=\"{$item['link_MODIFY']}\" title=\"" . $item['txt_MODIFY'] . "\" >" . $item['txt_MODIFY'] . "</a>";
		}
		echo $item['facebook_button_i_like'];
		echo "</div>";
		//footer ------<


		FN_CloseNews();
	}
}

if ( !function_exists("news__print_comment") )
{
	/**
	 *
	 * @param array $commentvalues
	 */
	function news__print_comment($commentvalues)
	{
		OpenTable();
		echo "<table border=\"0\" cellpadding=\"1\" cellspacing=\"1\" ><tr>";
		echo "<td valign=\"top\"><img src=\"{$commentvalues['img_USER']}\" alt=\"{$commentvalues['username']}\" /><br />{$commentvalues['html_USER']}</td><td  valign=\"top\">";
		echo $commentvalues['html_COMMENT'];
		echo "</td></tr></table>";
		if ( is_admin ( ) )
			echo "<div style=\"text-align:right\">[" . $commentvalues['html_DELCOMMENT'] . "]</div>";
		CloseTable();
		echo "<br />";
	}
}


if ( !function_exists("news__print_comments") )
{
	/**
	 * news__print_comments
	 * visualizza i commenti associati al record
	 *
	 * @param string unirecid record
	 */
	function news__print_comments($news_values)
	{
		global $_FN;
		$comments = $news_values['COMMENTS'];
		if ( $news_values['op'] != "comment" )
		{
			OpenTable();
			echo "<b>" . fn_i18n("_COMMENTI") . "</b> | <a href=\"{$news_values['link_WRITECOMMENT']}\">{$news_values['txt_WRITECOMMENT']}</a> | <a href=\"{$news_values['link_PRINT']}\">{$news_values['txt_PRINT']}</a>";
			CloseTable();
		}
		if ( count($comments) > 0 )
		{
			echo "<div class=\"newscomments\">";
			foreach ( $comments as $comment )
			{
				news__print_comment($comment);
			}
			echo "</div>";
		}
	}
}
function pubnews($idnews)
{
	global $_FN;
	$signewsmode = getparam("signews", PAR_GET, SAN_FLAT);
	$opt = getparam("opt", PAR_GET, SAN_FLAT);

	$Tablenews = xmldb_form("fndatabase", $_FN['news_tablename'], $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	$itemnews = $Tablenews->xmltable->GetRecordByPrimarykey($idnews);
	$sig = "";
	$gopt = "";
	if ( $opt != "" )
	{
		$gopt = "&amp;opt=$opt";
	}
	if ( $signewsmode != "" )
	{
		$sig = "&amp;signews=1";
	}
	if ( $itemnews['status'] != 1 )
		return "<form action=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=edit$sig$gopt") . "\" method=\"post\"><input name=\"pubnewsid\" value=\"$idnews\" type=\"hidden\"/><button type=\"submit\">" . fn_i18n("_PUBNEWS") . "</button></form>";
	else
		return "<form action=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=edit$sig$gopt") . "\" method=\"post\"><input name=\"hidenewsid\" value=\"$idnews\" type=\"hidden\"/><button type=\"submit\">" . fn_i18n("Hide_news") . "</button></form>";
}
function arguments_admin()
{
	global $_FN;
	$tablename = $_FN['news_tablename'];
	$signewsmode = getparam("signews", PAR_GET, SAN_FLAT);

	$op = getparam("op", PAR_GET, SAN_FLAT);
	$opt = getparam("opt", PAR_GET, SAN_FLAT); //if is controlcenter
	$gopt = "";
	if ( $opt != "" )
	{
		$gopt = "&amp;opt=$opt";
	}

	$imgedit = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/modify.png") . "\" alt=\"\" />";
	$imgedel = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/delete.png") . "\" alt=\"\" />";
	$imgeview = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/news.png") . "\" alt=\"\" />";
	$imgnew = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/add.png") . "\" alt=\"\" />&nbsp;";
	$imgback = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\" />&nbsp;";

	echo "<h3>" . fn_i18n("editarguments") . "</h3>";
	$params = array();
	$link = "mod={$_FN['mod']}&amp;op=$op$gopt";
	$params['link'] = $link;

	$params['textdelete'] = "<img title=\"" . fn_i18n("_ELIMINA") . "\" style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/delete.png") . "\" alt=\"\" />";

	$params['fields'] = "title|icon";
	$params['textnew'] = $imgnew . fn_i18n("_FNEWARG");
	echo "<div class=\"news_editor\">";
	FN_xmltableeditor($tablename . "_arguments", "fndatabase", $params);
	echo "</div>";
	if ( !isset($_GET["op___xdb_$tablename" . "_arguments"]) || $_GET["op___xdb_$tablename" . "_arguments"] == "" )
	{
		echo "<br /><br /><hr />";
		echo "<br />$imgeview&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=edit$gopt") . "\">" . fn_i18n("_SEGNNOTIZIE") . "</a>";
		echo "<br />$imgback<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}$gopt") . "\">" . fn_i18n("Back_to_the_news") . "</a>";
	}
}
/**
 *
 * @global <type> $_FN
 */
function news_admin()
{
	global $_FN;
	$tablename = $_FN['news_tablename'];
	$signewsmode = getparam("signews", PAR_GET, SAN_FLAT);

	$op = getparam("op", PAR_GET, SAN_FLAT);
	$opt = getparam("opt", PAR_GET, SAN_FLAT); //if is controlcenter
	$gopt = $sig = "";
	if ( $opt != "" )
	{
		$gopt = "&amp;opt=$opt";
	}
	if ( $signewsmode != "" )
	{
		$sig = "&amp;signews=1";
	}


	$imgedit = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/modify.png") . "\" alt=\"\" />";
	$imgedel = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/delete.png") . "\" alt=\"\" />";
	$imgeview = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/news.png") . "\" alt=\"\" />";
	$imgnew = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/add.png") . "\" alt=\"\" />&nbsp;";
	$imgback = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\" />&nbsp;";

	//---pub news---->
	$pubnewsid = getparam("pubnewsid", PAR_POST, SAN_FLAT);
	if ( $pubnewsid != "" )
	{

		$Tablenews = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
		$itemnews = $Tablenews->xmltable->GetRecordByPrimarykey($pubnewsid);
		if ( !empty($itemnews['unirecid']) )
		{
			$itemnews['status'] = 1;
			$itemnews = $Tablenews->xmltable->UpdateRecord($itemnews);
			if ( !empty($itemnews['status']) )
			{
				jsalert(fn_i18n("The_data_were_successfully_updated"));
			}
			else
			{
				jsalert(fn_i18n("_ERROR"));
			}
		}
	}
	//---pub news----<
	//hide news---->
	$pubnewsid = getparam("hidenewsid", PAR_POST, SAN_FLAT);
	if ( $pubnewsid != "" )
	{

		$Tablenews = xmldb_form("fndatabase", $tablename, $_FN['datadir'], $_FN['lang'], $_FN['languages']);
		$itemnews = $Tablenews->xmltable->GetRecordByPrimarykey($pubnewsid);
		if ( !empty($itemnews['unirecid']) )
		{
			$itemnews['status'] = "0";
			$itemnews = $Tablenews->xmltable->UpdateRecord($itemnews);
			if ( isset($itemnews['status']) )
			{
				jsalert(fn_i18n("The_data_were_successfully_updated"));
			}
			else
			{
				jsalert(fn_i18n("_ERROR"));
			}
		}
	}
	//hide news----<
	$params = array();
	$link = "mod={$_FN['mod']}&amp;op=$op&amp;$gopt$sig";
	$params['link'] = $link;
	$params['fields'] = "title|status|date|startdate|enddate|username|guestnews|pubnews()";
	$params['textnew'] = $imgnew . fn_i18n("_ADDNEWS");
	$params['textdelete'] = "<img title=\"" . fn_i18n("_ELIMINA") . "\" style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/delete.png") . "\" alt=\"\" />";
	$params['textview'] = fn_i18n("_ANTEPRIMA");
	$params['enableview'] = true;
	$params['textnorecord'] = fn_i18n("_NOPUBNEWS");
	$params['textviewlist'] = "<img style=\"border:0px;vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\" />&nbsp;" . fn_i18n("VIEWALL");
	$params['defaultorder'] = "date";
	$params['defaultorderdesc'] = true;
	$params['forcevaluesinsert'] = array("status"=>"0");
	//genera il txtid ---->
	$textid = "";
	if ( isset($_POST['title']) )
	{
		$generate_id = true;
		$pkid = getparam("unirecid", PAR_POST, SAN_FLAT);
		if ( $pkid != "" )
		{
			$Table = xmldb_form("fndatabase", $_FN["news_tablename"], $_FN['datadir'], $_FN['lang'], $_FN['languages']);
			$itemnews = $Table->xmltable->GetRecordByPrimarykey($pkid);
			if ( isset($itemnews['txtid']) && $itemnews['txtid'] != "" )
			{
				$generate_id = false;
			}
		}
		if ( $generate_id )
		{
			if ( $_POST['title'] != "" )//se esiste per la lingua di default
			{
				$textid = gen_txt_id($_POST['title'], $_FN["news_tablename"]);
			}
			else
			{
				foreach ( $_FN['listlanguages'] as $ll )
				{
					$idl = "";
					if ( $ll != $_FN['lang_default'] )
					{
						$idl = "_$ll";
					}
					if ( isset($_POST['title' . $idl]) )
					{
						$textid = gen_txt_id($_POST['title' . $idl], $_FN["news_tablename"]);
						break;
					}
				}
			}
		}
		$params['forcevaluesinsert'] = array("username" => $_FN['user'], "txtid" => $textid, "date" => fn_now());
	}
	//genera il txtid ----<

	if ( isset($_POST['body']) )
	{
		$_POST['body'] = news_makelinks_relative($_POST['body']);
	}
	if ( isset($_POST['summary']) )
	{
		$_POST['summary'] = news_makelinks_relative($_POST['summary']);
	}
	if ( empty($_GET['op___xdb_news']) )
	{
		if ( $signewsmode != "" )
		{
			$params['restr'] = array("status" => "0");
			echo "<h3>" . fn_i18n("Saved_news") . ":</h3>";
		}
		else
		{
			echo "<h3>" . fn_i18n("List_of_news") . ":</h3>";
		}
	}
	echo "<div class=\"news_editor\">";
	FN_xmltableeditor($tablename, "fndatabase", $params);
	echo "</div>";
	if ( empty($_GET["op___xdb_$tablename"]) || $_GET["op___xdb_$tablename"] == "del" )
	{
		if ( $signewsmode == "" )
		{
			$numsig = count_sig_news($tablename);
			echo "<hr />$imgeview&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=edit&amp;signews=1$gopt") . "\">" . fn_i18n("_SEGNNOTIZIE") . "</a> ($numsig)";
		}
		else
		{
			echo "<hr />$imgeview&nbsp;<a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=edit$gopt") . "\">" . fn_i18n("VIEWALL") . "</a>";
		}
		echo "<br /><br />$imgedit <a href=\"" . fn_rewritelink("?mod={$_FN['idmod']}&amp;op=editarguments$gopt") . "\">" . fn_i18n("editarguments") . "</a><br />";
	}
	elseif ( $_GET["op___xdb_$tablename"] == "view" )
	{
		$idnews = getparam("pk___xdb_$tablename", PAR_GET, SAN_FLAT);
	}
	//generate RSS----->
	if ( isset($_POST['body']) )
	{
		generate_RSS();
		if ( $_FN['news_generate_googlesitemap'] )
		{
			generate_GOOGLESITEMAP();
		}
	}
	//generate RSS-----<
}
/**
 * make 
 * @global array $_FN
 * @param string $str
 * @return string
 */
function news_makelinks_relative($str)
{
	global $_FN;
	$str = str_replace("=\"{$_FN['siteurl']}", "=\"", $str);
	$str = str_replace("='{$_FN['siteurl']}", "='", $str);
	$str = str_replace("url('{$_FN['siteurl']}", "url('", $str);
	$str = str_replace("url(\"{$_FN['siteurl']}", "url(\"", $str);
	$str = str_replace("url({$_FN['siteurl']}", "url(", $str);
	$str = str_replace("url(&quot;{$_FN['siteurl']}", "url(&quot;", $str);
	//se il post aggiunge gli '\'
	$str = str_replace("=\\\"{$_FN['siteurl']}", "=\\\"", $str);
	$str = str_replace("=\\'{$_FN['siteurl']}", "=\\'", $str);
	$str = str_replace("url(\\'{$_FN['siteurl']}", "url(\\'", $str);
	$str = str_replace("url(\\\"{$_FN['siteurl']}", "url(\\\"", $str);
	$str = str_replace("<br>", "<br />", $str);
	//dprint_xml($str);
	return $str;
}
?>
