<?php
/**
 * @package flatnux_section_gallery
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
define("THUMBSDIR","thumbs");
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
/**
 * ricava la lista delle foto presenti in una cartella
 * @param string directory
 * @param string extensions 
 */
function get_file_list($dir, $extensions)
{
	global $_FN;
	if (  !is_dir($dir) )
	{
		//echo "$dir not is folder";
		return false;
	}
	$handle_dir = opendir($dir);
	$list_images = array();
	$exts = explode(",",strtolower($extensions));
	while (false !== ($file = readdir($handle_dir)))
	{
		if (  !is_dir($dir . "/" . $file) && in_array(strtolower(get_file_extension($file)),$exts) )
		{
			$tmp = array();
			$tmp['url'] = "";
			if ( get_file_extension($file) == "link" )
			{
				$tmp['url'] = file_get_contents($dir . "/" . $file);
			}
			$filetitle = $dir . "/" . $file . "." . $_FN['lang'] . ".title.txt";
			$filedesc = $dir . "/" . $file . "." . $_FN['lang'] . ".txt";
			$filethumb = get_thumb_($dir . "/" . $file);
			//dprint_r($filetitle);
			$tmp['file'] = $dir . "/" . $file;
			$tmp['title'] = "";
			$tmp['description'] = "";
			if ( file_exists($filetitle) )
				$tmp['title'] = htmlspecialchars(file_get_contents($filetitle));
			if ( file_exists($filedesc) )
				$tmp['description'] = htmlspecialchars(file_get_contents($filedesc));
			$tmp['thumb'] = $filethumb;
			$list_images[] = $tmp;
		}
	}
	closedir($handle_dir);
	sort($list_images);
	return $list_images;
}
/**
 * get_thumb_
 * 
 * 
 * 
 */
function get_thumb_($filename)
{
	global $_FN;
	$path = substr($filename,0,strrpos($filename,"/"));
	$file_thumb = substr($filename,strrpos($filename,"/"),strlen($filename));
	$filenamethumb = $path . "/" . THUMBSDIR . "/" . $file_thumb;
	//dprint_r($filenamethumb);
	if ( file_exists($filenamethumb) )
	{
		return $filenamethumb;
	}
	if ( file_exists($filenamethumb . ".gif") )
	{
		return $filenamethumb . ".gif";
	}
	if ( file_exists($filenamethumb . ".png") )
	{
		return $filenamethumb . ".png";
	}
	if ( file_exists($filenamethumb . ".jpg") )
	{
		return $filenamethumb . ".jpg";
	}
	if ( file_exists($filenamethumb . ".jpeg") )
	{
		return $filenamethumb . ".jpeg";
	}
	if ( file_exists($filenamethumb . ".GIF") )
	{
		return $filenamethumb . ".GIF";
	}
	if ( file_exists($filenamethumb . ".PNG") )
	{
		return $filenamethumb . ".PNG";
	}
	if ( file_exists($filenamethumb . ".JPG") )
	{
		return $filenamethumb . ".JPG";
	}
	if ( file_exists($filenamethumb . ".JPEG") )
	{
		return $filenamethumb . ".JPEG";
	}
	if ( gg_is_Video($filename) )
		return ($_FN['siteurl'] . ("sections/{$_FN['vmod']}/video.png"));
	else
		return $filenamethumb . ".jpg";
}
/**
 * gg_is_Video
 * 
 * @param string nome del file
 * 
 * 
 * 
 */
function gg_is_Video($filename)
{
	global $movie_extensions;
	$exts = explode(",",strtolower($movie_extensions));
	if ( in_array(strtolower(get_file_extension($filename)),$exts) )
		return true;
	else
		return false;
}
?>
