<?php
/**
 * File delle funzioni di sistema
 *
 * offre le operazioni di scrittura di scrittura/eliminazione di files
 * cartelle, sezioni ecc. e controlla i permessi.
 *
 * @package Flatnux
 *
 * @author Simone Vellei <simone_vellei@users.sourceforge.net>
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
global $_FN;
include "./include/flatnux.php";
header("Content-Type: text/html; charset=" . _CHARSET, true);
echo "<html><body>";
fn_verify();
echo "</body></html>";
/**
 *
 * @global array $_FN
 * @global array $_FNMESSAGE
 */
function fn_verify()
{
	global $_FN, $_FNMESSAGE;
	if ( fn_is_external_referer ( ) )
	{
		echo fn_i18n("_NONPUOI");
		return;
	}

	$relativizelinks = 1;
	$remote_addr = getparam("REMOTE_ADDR", PAR_SERVER, SAN_FLAT);
	$from = "index.php";
	if ( $remote_addr == "" )
		$remote_addr = "none";
	$module = getparam("mod", PAR_GET, SAN_FLAT);
	if ( $module == "" )
		$module = getparam("mod", PAR_POST, SAN_FLAT);
	$getfrom = getparam("from", PAR_GET, SAN_FLAT);
	$postfrom = getparam("from", PAR_POST, SAN_FLAT);
	$refererfrom = getparam("HTTP_REFERER", PAR_SERVER, SAN_FLAT);
	if ( $getfrom != "" )
		$from = $getfrom;
	else // Se non esiste il GET di mod provo il POST
	{
		if ( $postfrom != "" )
			$from = $postfrom;
	}
	if ( $from == "" && $refererfrom != "" )
		$from = $refererfrom;
	switch ( $module )
	{
		case "" :
			jsredirect("index.php");
			break;
		case "delcontents" : //cancellazione di una cartella o di un file
			if ( !is_admin() )
			{
				echo fn_i18n("_NONPUOI");
				return;
			}

			$myfile = strippostpslashes(htmlspecialchars($_GET['file']));
			if ( isadmin ( ) )
			{
				$from = $refererfrom;
				if ( is_dir($myfile) )
				{
					FN_log("Deleted dir $myfile.");
					rmdir($myfile);
				}
				else
				{
					unlink($myfile);
					FN_log("Deleted file $myfile.");
				}
				write_static_index("{$_FN['datadir']}/index.html");
			}
			jsredirect($from);
			return;
			break;
		case "upload" : //upload di un file
			$from = $refererfrom;
			if ( isset($_POST['send']) )
			{
				$fileToOpen = getparam("location", PAR_POST, SAN_FLAT);
				$file_clean = str_replace("\\", '', $_FILES['filename']['name']);
				if ( !can_modify_file($_FN['user'], $fileToOpen . "/" . $file_clean) ) // se non e' un file valido
				{
					jsalert(_NONPUOI . " - " . _FILENOTCREATED);
				}
				elseif ( !move_uploaded_file($_FILES['filename']['tmp_name'], $fileToOpen . "/" . $file_clean) )
				{
					jsalert(_FILENOTCREATED);
				}
			}
			jsredirect($from);
			return;
			break;
		case "createnewfile" : //creazione di un file generico
			$getsection = getparam("section", PAR_GET, SAN_FLAT);
			$getfilename = getparam("filename", PAR_GET, SAN_FLAT);
			if ( can_modify_file($_FN['user'], "sections/$getsection/" . $getfilename) && versecid($_FN['user']) )
			{
				new_file($getfilename, $getsection);
				jsredirect($from);
				return;
			}
			break;
		case "newsection" : //aggiunge una sezione
			$dirtomake = "sections/";
			$sectionname = getparam("sectionname", PAR_POST, SAN_FLAT);
			$sectiontitle = getparam("sectiontitle{$_FN['lang_default']}", PAR_POST, SAN_FLAT);
			$sectionposition = getparam("sectionposition", PAR_POST, SAN_FLAT);
			$path = getparam("path", PAR_POST, SAN_FLAT);
			//verifica indice valido
			if ( $sectionposition != "none" && !is_numeric($sectionposition) )
			{
				jsalert(_FERRCAMPO . "\n$sectionname.");
				jsredirect($from);
				return;
			}
			//genera id valido
			if ( $sectionname == '' && $sectiontitle != "" )
			{
				$sectionname = strtolower(str_replace(" ", "_", $sectiontitle));
				$sectionname = preg_replace("//s", "a", $sectionname);
				$sectionname = preg_replace("//s", "a", $sectionname);
				$sectionname = preg_replace("//s", "e", $sectionname);
				$sectionname = preg_replace("//s", "e", $sectionname);
				$sectionname = preg_replace("//s", "i", $sectionname);
				$sectionname = preg_replace("//s", "i", $sectionname);
				$sectionname = preg_replace("//s", "o", $sectionname);
				$sectionname = preg_replace("//s", "o", $sectionname);
				$sectionname = preg_replace("//s", "u", $sectionname);
				$sectionname = preg_replace("//s", "u", $sectionname);
				$sectionname = preg_replace("/[^A-Z^a-z_]/s", "", $sectionname);
				$t = "";
				while ( 1 )
				{
					$sectionname = $sectionname . $t;
					if ( find_section($sectionname) == "" )
					{
						break;
					}
					else
					{
						if ( $t == "" )
							$t = 0;
					}
					$t++;
				}
			}
			if ( $sectionname == '' )
			{
				jsalert(_FERRCAMPO . "\n" . _TITLE . ":" . _FNREQVALIDFIED);
				jsredirect($from);
				return;
			}
			if ( $path != "" )
				$dirtomake .= $path . "/";
			$pos = "";
			if ( $sectionposition != "" )
			{
				$pos = $sectionposition;
				if ( is_numeric($sectionposition) && $sectionposition < 10 && $sectionposition[0] != "0" )
					$pos = "0$pos";
				$pos .= "_";
			}
			$dirtomake .= $pos;
			$dirtomake .= $sectionname;
			//se esiste gia'
			$mloc = $path . "/$sectionname";
			if ( sectionlocation($mloc) !== false )
			{
				jsalert($sectionname . ": " . _ALREADYEXISTS);
				jsredirect($from);
				return;
			}
			if ( can_modify_file($_FN['user'], $dirtomake . ".tmp") && !file_exists($dirtomake) )
			{
				mkdir($dirtomake);
				$htaccess = '<FilesMatch "\.htm">
order deny,allow
deny from all
</FilesMatch>

<FilesMatch "\.html">
order deny,allow
deny from all
</FilesMatch>

<FilesMatch \.php>
order allow,deny
allow from all
</FilesMatch>';
				$h = fopen("$dirtomake/.htaccess", "w"); //evita l' accesso diretto ala sezione
				fwrite($h, "$htaccess");
				fclose($h);
				if ( file_exists($dirtomake) )
				{
					$fps = fopen($dirtomake . "/" . $sectionname . ".section", "w");
					fwrite($fps, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
					fclose($fps);
					touch($dirtomake . "/lang.xml");
					if ( file_exists("$dirtomake/../level.php") )
					{
						copy("$dirtomake/../level.php", $dirtomake . "/level.php"); //eredita il livello
					}
					$mess = str_replace("{sectionname}", $sectiontitle, _ALERTSECTIONCREATE);
					jsalert($mess);
					if ( $sectiontitle == "" )
					{
						$sectiontitle = str_replace("_", " ", $sectionname);
					}
					foreach ( $_FN['listlanguages'] as $llang )
					{
						$title = getparam("sectiontitle$llang", PAR_POST, SAN_FLAT);
						if ( $title != "" )
							set_section_title($dirtomake . "/lang.xml", strippostpslashes($title), $llang);
					}
				}
				else
				{
					jsalert(_ALERTSECTIONOTCREATE);
				}
			}
			write_static_index("{$_FN['datadir']}/index.html");
			jsredirect($from);
			break;
		case "changesectiontitle" : //cambia il titolo a una sezione
			$sectionname = getparam("sectionname", PAR_POST, SAN_FLAT);
			$newpath = "sections/" . getparam("newpath", PAR_POST, SAN_FLAT);
			if ( !is_admin() )
				$newpath = dirname($sectionname);
			if ( $sectionname != "" )
			{
				$from = "index.php?mod=$sectionname";
				$sectionbasename = basename($sectionname);
				$sectiondir = preg_replace("/" . str_replace('/', '\\/', $sectionbasename) . "\$/s", "", $sectionname);
				//cambia il titolo della sezione  --------->
				if ( !can_modify_file($_FN['user'], $_POST['sectionname'] . "/lang.xml") )
				{
					echo fn_i18n("_NONPUOI");
					return;
				}

				foreach ( $_FN['listlanguages'] as $l )
				{
					set_section_title($_POST['sectionname'] . "/lang.xml", strippostpslashes($_POST['sectiontitle_' . $l]), $l);
				}
				$from = getparam("from", PAR_GET, SAN_HTML);
				write_static_index("{$_FN['datadir']}/index.html");
				$pos = getparam("pos", PAR_POST, SAN_FLAT);
				//cambia il titolo della sezione  ---------<
				//cambia la posizione della sezione ------->
				if ( $pos != "" )
				{
					if ( preg_match("/^[0-9]+_|^none_/si", $sectionbasename) )
					{
						$newname = "$sectiondir" . preg_replace("/^[0-9]+_|^none_/si", $pos . "_", $sectionbasename);
					}
					else
					{
						$newname = $sectiondir . $pos . "_$sectionbasename";
					}
					if ( !file_exists($newname) )
					{
						if ( file_exists("$sectionname") )
						{
							rename($sectionname, $newname);
							$sectionname = $newname;
						}
						$from = "index.php?mod=" . str_replace("sections/", "", $newname);
					}
				}
			}
			if ( $newpath != "" && dirname($sectionname) != $newpath && file_exists($newpath) && is_dir($newpath) && !file_exists($newpath . "" . basename($sectionname)) )
			{
				//dprint_r("sposto $sectionname in $newpath");
				if ( fn_movedir($sectionname, $newpath, false)

					);
				{
					if ( $newpath != "" )
						$newpath = "$newpath/";
					$from = "index.php?mod=" . str_replace("sections/", "", $newpath . basename($sectionname));
				}
			}
			jsredirect($from);
			break;
		case "delsection" : //elimina una sezione vuota
			if ( !can_modify($_FN['user'], "sections/" . $_GET['sectionname']) )
			{
				echo fn_i18n("_NONPUOI");
				return;
			}
			$dirtomake = "sections/";
			if ( isset($_GET['path']) && $_GET['path'] != "" )
				$dirtomake .= $_GET['path'] . "/";
			$dirtomake .= $_GET['sectionname'];
			if ( false != ($objs = glob($dirtomake . "/*")) )
			{
				foreach ( $objs as $obj )
				{
					if ( is_dir($obj) )
					{
						jsalert(_SECTIONISNOTEMPTY);
						jsredirect($from);
					}
				}
			}
			if ( false != ($objs = glob($dirtomake . "/*")) )
			{
				foreach ( $objs as $obj )
				{
					unlink($obj);
				}
			}
			@unlink($dirtomake . "/.htaccess");
			rmdir($dirtomake);
			write_static_index("{$_FN['datadir']}/index.html"); //*/
			jsredirect($from);
			break;
		case "deldir" : //elimina una cartella in modo ricorsivo
			if ( !isadmin() )
			{
				echo fn_i18n("_NONPUOI");
				return;
			}

			$dirtodelete = getparam("file", PAR_GET, SAN_FLAT);
			if ( $dirtodelete == "" )
			{
				echo fn_i18n("_NONPUOI");
				return;
			}

			if ( strstr($dirtodelete, "..") )
			{
				echo fn_i18n("_NONPUOI");
				return;
			}

			if ( strstr($dirtodelete, "{$_FN['datadir']}/foto/") == false ) //per ora posso cancellare soltanto cartelle che sono sotto {$_FN['datadir']}/foto
			{
				echo fn_i18n("_NONPUOI");
				return;
			}

			rmdird($dirtodelete);
			write_static_index("{$_FN['datadir']}/index.html");
			jsredirect($from);
			break;
		case "modlevel" : // modifica il livello di una sezione
			$section = getparam("section", PAR_POST, SAN_FLAT);
			if ( $section == "" )
			{
				echo (_NONPUOI);
				return;
			}
			$perm = getsectperm("sections/$section/");
			$newuser = isset($_POST['user']) ? $_POST['user'] : $perm['user'];
			$newgroup = isset($_POST['group']) ? $_POST['group'] : $perm['group'];
			$newuserview = isset($_POST['user_view']) ? $_POST['user_view'] : $perm['user_view'];
			$newgroupview = isset($_POST['group_view']) ? $_POST['group_view'] : $perm['group_view'];
			$newlevel = isset($_POST['level']) ? $_POST['level'] : $perm['level'];
			if ( isadmin ( ) )
			{
				if ( $newlevel == -1 && $newuser == "" && $newgroup == "" && $newuserview == "" && $newgroupview == "" ) // se e' tutto vuoto elimino il file
				{
					unlink("sections/$section/level.php");
					FN_log("Section $section with no more level restrictions.");
				}
				else
				{
					$fp = fopen("sections/$section/level.php", "w");
					fwrite($fp, "<?php exit(0);?>\n");
					fwrite($fp, "$newlevel\n");
					fwrite($fp, "$newuser\n");
					fwrite($fp, "$newgroup\n");
					fwrite($fp, "$newuserview\n");
					fwrite($fp, "$newgroupview\n");
					fclose($fp);
					FN_log("Level of the section $section modified level: $newlevel user :$newuser  group: $newgroup.");
				}
				jsredirect("index.php?mod=$section");
			}
			break;
		case "modleveldir" : // modifica il livello di una cartella
			$section = $_POST['dir'];
			$level = $_POST['level'];
			if ( isadmin ( ) )
			{
				if ( $level != -1 )
				{
					$fp = fopen("$section/level.php", "w");
					fwrite($fp, "$level");
					fclose($fp);
					FN_log("Level of the dir $section modified to $level.");
				}
				else
				{
					unlink("$section/level.php");
					FN_log("Dir $section with no more level restrictions.");
				}
				jsredirect($from);
			}
			break;
		case "restorefile" :
			$filetorestore = getparam("filetorestore", PAR_GET, SAN_FLAT);
			$fileinfo = explode(".", $filetorestore);
			$userm = $fileinfo[count($fileinfo) - 2];
			$ori = preg_replace('/.' . $fileinfo[count($fileinfo) - 3] . '.' . $userm . '.bak~$/s', "", $filetorestore);
			// se e' readonly
			if ( file_exists($ori) && !is_writable($ori) )
			{
				jsalert(_READONLY);
			}
			else
			{
				// se l' utente puo' modificare il file
				if ( can_modify_file($_FN['user'], $ori) )
				{
					if ( file_exists($ori) )
						backup_file($ori);
					$handle = fopen($ori, "w");
					fwrite($handle, file_get_contents($filetorestore));
					jsalert($_FNMESSAGE['FILERESTOREOK']);
				}
				else
					jsalert(_NONPUOI);
			}
			jsredirect($from);
			break;
		case "modconfig" :
			if ( !is_admin() )
			{
				echo fn_i18n("_NONPUOI");
				return;
			}

			$conf_file = null;
			if ( isset($_POST['conf_file']) )
				$conf_file = strippostpslashes($_POST['conf_file']);
			else
			if ( isset($_GET['conf_file']) )
				$conf_file = strippostpslashes($_GET['conf_file']);
			$fd = file($conf_file);
			;
			$j = 0;
			$new_file = "";
			// scansione file alla ricerca delle variabili
			for ( $i = 0; $i < count($fd); $i++ )
			{
				$postvar = str_replace('$', '\$', str_replace("[", "\[", str_replace("]", "\]", strippostpslashes($_POST["conf_field$j"]))));
				if ( preg_match('/^' . $postvar . "./s", $fd[$i]) )
				{
					$oldvalue = xmldb_encode_preg(strippostpslashes($_POST["conf_value_old$j"]));
					$newvalue = xmldb_encode_preg_replace2nd(strippostpslashes($_POST["conf_value$j"]));
					if ( $oldvalue == "" )
						$new_file .= preg_replace('/=(.*?)("")/s', '=${1}"' . $newvalue . '"', $fd[$i]);
					else
						$new_file .= preg_replace('/=(.*?)(' . $oldvalue . ')/s', '=${1}' . $newvalue, $fd[$i]);
					if ( $j < ($_POST['conf_num'] - 1) )
						$j++;
				}
				else
				{
					$new_file .= $fd[$i];
				}
			}
			/* 		dprint_r($_POST);
			  dprint_xml($new_file); */
			$fd = fopen(stripslashes($conf_file), "wb");
			fwrite($fd, $new_file);
			fclose($fd);
			//dprint_xml($new_file);

			jsredirect($from);
			break;
		case "modcont" :
			$file = null;
			// file to modify --->
			if ( isset($_POST['file']) )
			{
				$file = strippostpslashes(getparam("file", PAR_POST, SAN_FLAT));
			}
			else
			{
				if ( isset($_GET['file']) )
					$file = strippostpslashes(getparam("file", PAR_GET, SAN_FLAT));
			}
			// file to modify ---<
			// file to delete --->
			if ( isset($_GET['delfile']) )
			{
				if ( !can_modify_file($_FN['user'], $file) )
				{
					echo fn_i18n("_NONPUOI");
					return;
				}

				if ( can_modify_file($_FN['user'], $file) )
				{
					//se non e' gia' un file di backup
					if ( !preg_match('/.bak~$/si', $file) )
						backup_file($file);
					unlink($file);
					FN_log("File " . $file . " deleted.");
					write_static_index("{$_FN['datadir']}/index.html");
					jsalert(_FILEDELETED . "\n$file.");
					jsredirect($from);
				}
				echo "</body></html>";
				return;
			}
			// file to delete ---<
			// file contents ---> 
			$mybody = isset($_POST['body']) ? $_POST['body'] : "";
			$mybody = strippostpslashes($_POST['body']);
			if ( !is_admin() )
			{
				$mybody = str_replace("<?", "&lt;?", $mybody);
				$mybody = str_replace("?>", "?&gt;", $mybody);
			}
			if ( versecid($_FN['user']) and file_exists($file) and can_modify_file($_FN['user'], $file) )
			{
				if ( stristr($file, "..") )
				{
					echo fn_i18n("_NONPUOI");
					return;
				}

				if ( $relativizelinks == 1 && isset($_POST['linktolocal']) ) //ritrasformo i links assoluti in relativi
				{
					$sdir = dirname($file); //percorso del file
					$sdir1 = dirname($file); //percorso del file
					$url = $_FN['siteurl'];
					$sdir = $url . $sdir . "/";
					$mybody = str_replace($sdir, '', $mybody);
					$sub = explode("/", $sdir1);
					$r = "";
					foreach ( $sub as $s )
					{
						if ( $s !== "" )
						{
							$r .= "../";
						}
					}
					$mybody = str_replace($_FN['siteurl'], $r, $mybody);
				}
				// genero un file di backup
				if ( file_get_contents($file) != "" )
					backup_file($file);
				$fp = fopen($file, "w");
				// questa write non sembra aver
				// bisogno di un controllo su accesso concorrente
				fwrite($fp, "$mybody");
				fclose($fp);
				FN_log("File " . $file . " modified.");
				jsredirect($from);
			}
			// modify file contents ---<
			break;
	}
}
?>